# Patch file for Keen 58- The Ruin Of Roib - use with CK4PATCH.EXE
###NOTE: Most, if not all, of the little messages after a line of patch code is taken straight from the original examples and don't represent what i did with them, e.g if it says '#blahblah +3'
###it doesn't mean that the value in the code on that line *is* +3, i might've changed it. its just what the original was. i usually only wrote my own messages above any code, in the 'titles' 
###of paragraphs of code.

%ext ck4

%gamemaps editmaps.ck4
#%gamemaps custmaps.ck4
%maphead maphead.ck4
%egahead EGAHEAD.CK4

%patch $200E2 $CB 

%patch $89FD  $067FW 

#%dump DUMP.DAT

%patchfile $249C2 "keen4.tli" # for Keen 4

#Keenwave patch file; Patch sounds:
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary

#Keen can enter doors 1 tile wide (Walks right 2 pixels instead of 6)
%patch $B9C0 $0000W

#WoW exits normally
%patch $9059 $90

#Keen can exit the WoW normally (Going offscreen)
%patch $9056 $83 $3E $A7EDW  $11 $90 $90

#Screen colors:
%patch $95FB $0000W #Color dark red used for screen background

#Help screen colors:
%patch $98F5 $0000W #Color
%patch $98F9 $00C8W #200x...
%patch $98FD $0140W #320...
%patch $99F8 $0000W #Color used behind help pointer

#This controls the position of the frames of level loading anim (keen giving thumbs up)
%patch $6478 $0000W #Y pos
%patch $647F $002DW #X pos

#This controls the position of the frames of level loading anim (keen giving thumbs up)- for after you die (different for some reason)
%patch $640D $0000W #Y pos
%patch $6414 $002DW #X pos




#################################################
#####DOS SCREEN STUFF
#################################################

#%patch $33580 "Mash Keyboard   " $00
#%patch $33566 "Mash Keyboard   " $00

%patch $38AD  $90 $90 $90 $90 $90 #Don't load B800
%patch $38D0  $90 $90 $90 $90 $90 #Don't display game info
%patch $19F40 $90 $90 $90         #Don't show 'Loading...' text
%patch $19FA6 $90 $90 $90         #Don't show 'Ready' text
%patch $39B2 $90 $90 $90 $90 $90  #Don't wait for key

#this is for the dos screens at the beginning and end
%patchfile $1FE47 ck4load.bin




#################################################3
#####LEVEL MARKER 'FLAGS'
################################################

#Flipping flag- sprite behaviour
%patch $304E6 $0D8F0BC4RL #Appear with a pop sound
%patch $30504 $00000000L
%patch $30522 $00000000L
%patch $30540 $00000000L
%patch $3055E $00000000L
%patch $3057C $00000000L
%patch $3059A $00000000L

#Sitting flag
%patch $3045E $012AW $012AW
%patch $3047C $012BW $012BW
%patch $3049A $012CW $012CW
%patch $304AA $0D8F0BC4RL 
%patch $304B8 $012DW $012DW
%patch $304D4 $1666W
%patch $304D6 $012EW $012EW
%patch $304F4 $012FW $012FW
%patch $30512 $0130W $0130W
%patch $30530 $0131W $0131W $0002W

%patch $304E6 $00000000L
%patch $304DA $0000W
%patch $30504 $00000000L
%patch $304F8 $0000W
%patch $30522 $00000000L
%patch $30516 $0000W
%patch $30540 $00000000L
#%patch $30534 $0000W
%patch $3055E $00000000L
%patch $30552 $0000W
%patch $3057C $00000000L
%patch $30570 $0000W
%patch $30594 $000CW
%patch $3059A $00000000L
%patch $3058E $0002W

#Flags are always sitting
%patch $6146 $0D8F09FDRL





######################################
#####GETTING ABILITIES VIA SCORE PATCHES, PLUS MISC CHEAT CODE RELATED PATCHES
#######################################

#Disable boss cheat
#%patch $7A40 $EB

#Remove F10 key (Just press letter for cheat)
#%patch $7ABE $90 $90

#Debug keys always on (dont need a+2+enter)
#%patch $7AB7 $90 $90

#the top 4 scores in highscore board to use
#$009C4000L-god		10,240,000
#$004E2000L-king gak	5,120,000
#$00271000L-kreeg		2,560,000
#$00138800L-boboi		1,280,000

#%patch $73CE $0009W #Window height
#%patch $73D2 $0024W #Window width

#text- taking over 'border color' cheat
#%patch $2F362 "250,000 score!" $0A $0A
#		  "You have reached the" $0A
#		  "status of King Gag," $0A 
#		  "leader of the Yakki" $0A $0A
#		  "You too may reach high places" $00

#text- taking over 'border color' cheat
#%patch $2F362 "250,000 score!" $0A $0A
#		  "You have reached the status of" $0A
#		  "Boboi, your lost love." $0A $0A
#		  "These gems highten your beauty." $00



#%patch $73B6 $00C8W $72 $7A54W 

#%patch $73AC $83 $3E $7A50W $C8 $73 $03 $5E $5D $CB $9A $19311070RL $5E $5D $CB

#makes pressing CTRL brings up border cheat
#%patch $73B6 $C681W

#makes pressing CTRL brings up god mode cheat
#%patch $74C0 $C681W

#this makes my idea basically work! it checks if the score is above a certain number and gives the messages and goodies
#the 7A52 high score thing and the number next to it equals to 65,000 points for 1 (so having $7A52W $02 equals to around 130,000 score)
#%patch $73B5 $3E $7A50W $64 $73 $03 $E9 $008EW $9A $19311070RL 

#%patch $744A $EB $FF 

#%patch $73B4 $E9 $0095W

#%patch $73D5 $5F $5E $8B $5D $CB

#%patch $73B5 $3E $7A50W $64 $74

#Disable god mode
#%patch $74CA $EB


#now doing it for the F10+I 'free items' cheat
#%patch $751B $3E $7A52W $01 $75 $60

#%patch $7581 $E9 $0001W
#%patch $7585 $9A $06BD09B1RL


#new jump to be made to new code below
#%patch $74C4 $4E

#put jumps in there to try and make the fucker work
#%patch $7512 $3E $7A52W  $01 $73 $02 $EB $66 $8B $3E  $7A50W $0A $73 $60  #formerly at 751B

#put jumps in there to try and make the fucker work
#%patch $7514 $3E $7A52W  $01 $73 $66 $8B $3E  $7A50W $0A $73 $60  #formerly at 751B


#put jumps in there to try and make the fucker work
#%patch $7513 $83 $3E $7A50W  $64 $7E $67 $90 $90 $90 $90 $90 $90 $90  #formerly at 751B
#		 $9A $1D060999RL $B8 $03 $00 $50 $B8 $0C $00 $50 
#		 $9A $19311070RL $83 $C4 $04 $B8 $21 $05 $50 $9A 
#		 $19310E1FRL     $83 $C4 $02 $33 $F6 $EB $0B $8B $DE 
#		 $D1 $E3 $C7 $87 $60 $7A $63 $00 $46 $83 $FE $04 $7C 
#		 $F0 $C7 $06 $58 $7A $63 $00 $C7 $06 $5C $7A $01 $00 
#		 $9A $1D060A9BRL $9A $14600EDFRL $B8 $B8 $0B 
#		 $50 $90 $0E $E8 $4D $15 $83 $C4 $02 $B8 $01 $00 $5F 
#		 $5E $8B $E5 $5D $CB # $E9 $004BW
#
#what score it gives 
#%patch $756D $000AW

#for just before the start of the above code
#%patch $750D $5F $5E $8B $E5 $5D $CB




######################################
######MAIN MENU
######################################

%patch $33656 "BE IN EA   GAME" $00
              "B GIN NORMAL GAM " $00
              "BEGIN HARD  AME" $00
%patch $3372F "NEW G ME" $00 
              "LOAD GAME" $00 
              "SA E GAME" $00
              " ONFIGURE" $00 
              "END GA E" $00 
              "PAD LE WAR" $00
              "Q  T" $00

#Options menu
%patch $33874 "SCORE BO  (ON)" $00
              "SCORE BO  (OFF)" $00
%patch $33893 "TWO  UTTON FIRING (ON)" $00
              "TWO  UTTON FIRING (OFF)" $00
%patch $338C2 "FIX JERKY MO  ON (ON)" $00
              "FIX JERKY MO  ON (OFF)" $00
%patch $338EF "SVGA  OMPATIBILITY (ON)" $00
              "SVGA  OMPATIBILITY (OFF)" $00
%patch $33920 "USE GRAVIS GAMEP   (ON)" $00
              "USE GRAVIS GAMEP   (OFF)" $00
%patch $33951 " core box now on" $00
              " core box now off" $00
              "Press any k y" $00
%patch $33CCA "RETURN T  GAME" $00 
              "PR GRESS" $00
%patch $33D11 "Quitting..." $00

%patch $1A9C6 $B0 $08 $50 #Background 1 (Dark grey)
              $B0 $08 $50 #Background 2 (Should match back 1)
              $B0 $82 $50 #Width of background box- orig $82= $9F




#####################################
#####PADDLE WAR
#####################################

%patch $1C675 $0032W #PP BG box width

#Player Paddle
#%patch $1C692 $0081W #Player Paddle sprite
%patch $1C66D $0008W #PP background color
%patch $1C671 $0003W #PP BG box height
%patch $1C675 $001CW #PP BG box width
%patch $1C679 $0087W #CP sprite v location 1
%patch $1C696 $0087W #CP sprite v location 2

#%patch $4F91 $0081W 

#Ball
%patch $1C620 $007EW #Ball sprite 1
%patch $1C625 $007DW #Ball sprite 2
%patch $1C5FA $0008W #B background color
%patch $1C5FE $0015W #B BG box height AND width
%patch $1C350 $0008W #B background color 2
%patch $1C354 $0015W #B BG box height AND width 2




######################################
#######GAME INTRO
######################################

#Terminator chunks:
#%patch $4EE8 $1279W #COMMANDER
#%patch $4EF4 $1282W #KEEN

#something do with the the X position of the 'Keen' word in intro (makes it blink though)
%patch $4F91 $0073W

#makes the 'keen' word in intro blink/flicker
#%patch $4F97 $90 $90 $90 $90 $90

#something to do with the 'commander' word's length- causes lots of noise on screen, but makes for an interesting arty intro
#%patch $4FB7 $0000W

#makes the credits that come up wobble
%patch $4012 $0001W

#makes the credits get noise/garbage come over it at times. good for a 'fucked up' effect
%patch $4012 $0015W

#controls the X position of the credits
%patch $402C $000CW

#creates an interesting trail behind the credits as they move
#%patch $406E $0002W

%patch $40B4 $0002W

#makes the credits hit the top of the screen, stop, then float to the right, leaving behind all manner of graphics corruption
#%patch $40D7 $00F0W

#makes it all fucked up quite badly, but still usable and interesting (looking like the intro to a david fincher movie)
#%patch $411B $00F2W

#this makes the credits suddenly appear in the middle of the screen- though first two credits cause some gfx glitches
#%patch $4217 $FFFFW

#messes up credit's upward movement, + more gfx glitch
%patch $4230 $FFFFW
%patch $51C4 $0000W

#creates more fucked up effect
%patch $5073 $FFF1W

%patch $5209 $0016W

#This makes the star wars story appear after the title screen- then goes to the menu
%patch $521B $9A $03ED18B8RL #$E5 $5D $CB

########'star wars' story#########

#%patch $5587 $FFF1W  #Plus this

#Story read from
#%patch $5582 $1ED3RW #This * $10
#%patch $5587 $0191W  #Plus this

#%patchfile $1EE40 "story.ck4" #for 'star wars' scrolling text
#"|---------------------|"
%patch $1EE40
"Thirty five year old" $0A
"William Blaze- drunk," $0A
"unemployed and everyone" $0A
"treating him like dirt-" $0A 
"remembers his space" $0A
%patch $1EEAF
"adventures he had as a" $0A
"kid, and decides" $0A
"to once again transform" $0A
"to COMMANDER KEEN for" $0A 
"one last time, to blast" $0A
"off into the stars" $0A 
"forever." $0A

%patch $1EF39
$0A
"Finding his ship in the" $0A
"local dump, he gets" $0A
"distress calls from" $0A
"planet Roib. " $0A

%patch $1EF88 
$0A
"Fumbling with the ships" $0A
"controls, forgetting" $0A
"how he flew the damn" $0A
"thing, Keen eventually" $0A
"gets to Roib, but" $0A
"sees that hes too late." $0A
"Roib is destroyed." $0A
$0A
"Oops." $00 $00 $00 $00 $00 $00 



#######################################
######DEMO STUFF
######################################

#Main menu actions list
%patch $3CB9 $0448W #3C18: Terminator sequence and title screen
             $0481W #3C2F: Demo 1
             $046CW #3C3C: Star wars story
             $0481W #3C43: Demo 2
             $046CW #3C51: High score demo
             $0481W #3C58: Demo 3
             $046CW #3C66: Demo 4

#disable demos, except high score demo
%patch $3C32 $90 $90 $90 $90 $90 #Demo 1
%patch $3C47 $90 $90 $90 $90 $90 #Demo 2
%patch $3C5C $90 $90 $90 $90 $90 #Demo 3
%patch $3C6C $90 $90 $90 $90 $90 #Demo 4

#NOTE: DEMO4.CK4 is the demo for the highscore level




#######################################
########HIGH SCORES
######################################

#Don't ever add Keen's score to high scores
#%patch $6BB6 $90 $90 $90 $90 $90

#Names in the highscores
%patch $33234 "                 " $00
%patch $33274 "                 " $00
%patch $332B4 "                 " $00
%patch $332F4 "                 " $00
%patch $33334 "                 " $00
%patch $33374 "                 " $00
%patch $333B4 "                 " $00
%patch $333F4 "                 " $00

#Points: (10'000)
%patch $3326E $009C4000L #10,240,000
%patch $332AE $004E2000L
%patch $332EE $00271000L
%patch $3332E $00138800L
%patch $3336E $0009C400L
%patch $333AE $0004E200L
%patch $333EE $00027100L
%patch $3342E $00013880L #80,000

#What is displayed in the 'saved' column- whether level 24 is completed or not (and it never is- so it'll always be zero. swish)
%patch $6BAC $7A4EW


########Highscore 'rank list' item

#put the item in the egg cache/have some free frames here from council members, which are just before the egg frames
%patch $30718 $0169W #Egg Cache start

#overtaking 'dart hard right' slot/pointer
%patch $EF2B $0453W

#this code is overtaking some of 'dart shooter- medium' code, which starts at $ED53
%patch $ED43 $FF $76 $FC $57 $9A $0E8F0FAERL  $83 $C4 $04 $C7 $06 $83 $CB
             $0001W  $E9 $00A5W

#overtaking some of the 'Keen swimming 2' behaviour code- $0E8F0FAERL 
%patch $F89E $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $47 $20 $0003W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $25D0W  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $31440 $0169W $0169W $0000W $0000W $0000W $0000W $0000W $0000W
%patch $31450 $00000000L $00000000L $09DC176ERL $25D0W




######################################################
######MEGACANDY ITEMS
######################################################

#####MEGA-COLA

%patch $EECD $0469W # 'Mum' tile

#taking over the rest of the dart initiation codes. making it cache 1 frames.
%patch $ED59 $FF $76 $FC $57 $9A $2EE74080RL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00D8W $E9 $0087W 

#spawning code- taking over error messages- $2EE74080RL
%patch $32EF0 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $25EEW  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $3145E $00D8W $00D8W $0000W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE73FD6RL $09DC176ERL $25EEW
#$260CW
%patch $3147C $00D5W $00D5W $0002W $0000W $0000W $0100W $0000W $0000W
		  $11A20E01RL $00000000L $11A20CA1RL    $0000W

#megacandy collision- $2EE73FD6RL -gives 30,000 score, plays a sound, shows 'got image'
%patch $32E46 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $1D
             $B8 $7530W  $50 $9A $06BD1EF2RL $83 $C4 $02 $C7 $44 $1C $260CW $B8 $0025W $50 
		  $9A $187409F1RL $83 $C4 $02 $5F $5E $5D $CB



#####MEGA-CUPCAKE

%patch $EECF $0FEAW # 'dad' tile

#init. code- overtaking 'keen swimming 2' behaviour
%patch $F8DA $FF $76 $FC $57 $9A $2EE740F7RL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00D6W $E9 $F506W 

#overtaking more error messages- $2EE740F7RL
%patch $32F67 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $2684W  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $314F4 $00D6W $00D6W $0000W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE73FD6RL $09DC176ERL $2684W



#####MEGA-MILKSHAKE

%patch $EED1 $1007W #a blank tile

%patch $F8F7 $FF $76 $FC $57 $9A $2EE74132RL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00D9W $E9 $F4E9W 

#overtaking more error messages- $2EE74132RL
%patch $32FA2 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $26A2W  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $31512 $00D9W $00D9W $0000W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE73FD6RL $09DC176ERL $26A2W



#####MEGA-JELLO

%patch $EED3 $1024W #a blank tile

%patch $F914 $FF $76 $FC $57 $9A $2EE7416DRL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00DAW $E9 $F4CCW

#overtaking more error messages- $2EE7416DRL
%patch $32FDD $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $26C0W  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $31530 $00DAW $00DAW $0000W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE73FD6RL $09DC176ERL $26C0W



#####MEGA-CAKE

%patch $EED5 $1041W #a blank tile

%patch $F931 $FF $76 $FC $57 $9A $2EE741A8RL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00DBW $E9 $F4A3W

#overtaking more error messages- $2EE741A8RL
%patch $33018 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $3908W  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $32778 $00DBW $00DBW $0000W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE73FD6RL $09DC176ERL $3908W



######MEGA-PEZZ

%patch $EED7 $0419W #'swim keen' tile

#overtaking some of the 'swimming keen' intiation code - 
%patch $ED09 $FF $76 $FC $57 $9A $2EE741E3RL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00DCW $E9 $00D7W

#overtaking more error messages- $2EE741E3RL
%patch $33053 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		  $8B $46 $08 $D3 $E0 $05 $FF00W $89 $47 $0C $B8 $3926W  $50 $53 
		  $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $32796 $00DCW $00DCW $0000W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE73FD6RL $09DC176ERL $3926W






################################################
######GEM TREE ITEM
###############################################

#'medium up dart' pointer local
%patch $EF21 $03FBW

#taking over some of the 'swimming keen' intiation code - only caching the 'gem got' sprite (the visual tree is made of tiles)
%patch $ECEB $FF $76 $FC $57 $9A $2EE740BBRL $83 $C4 $04 $B8 $2A3ARW $8A 
             $16 $EC $7A $8E $C0 $26 $08 $16 $00FAW $E9 $00F5W 

#overtaking more error messages- $2EE740BBRL
%patch $32F2B $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $47 $20 $0003W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A 
		 $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C $B8 $262AW  $50 $53 
		 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#$262AW
%patch $3149A $00FAW $00FAW $0003W $0000W $0000W $0000W $0000W $0000W
		  $00000000L $2EE7401CRL $00000000L  $262AW
#$2648W
%patch $314B8 $00FAW $00FAW $0003W $0000W $0000W $0048W $0000W $0000W
		  $00000000L $00000000L $09DC176ERL    $2666W
%patch $314D6 $FFFFW $FFFFW $0003W $0000W $0000W $0032W $0000W $0000W
		  $00000000L $00000000L $09DC176ERL    $262AW

#collision- $2EE7401CRL- did a jump condition deal here where if its level 11 then you get a green gem, if not, then a red gem
%patch $32E8C $55 $8B $EC $56 $8B $76 $08 $83 $3C $02 $75 $20 $B8 $2648W $50 
		  $FF $76 $06 $9A $09DC120ARL $83 $C4 $04 $B8 $0013W $50 
		  $9A $187409F1RL $83 $C4 $02 $83 $3E $A7EDW $0B $75 $09 $C7 $06 $7A66W $0001W $E9 $0006W $C7 $06 $7A60W $0001W $5E $5D $CB



#############################################
####MISC ITEM STUFF
###########################################

#this is the image that pops up when you collect 100 drops/flowers
%patch $D0C7 $009FW

#Ammo stunners give Keen
%patch $30246 $0007W #Easy
              $0006W  #Medium
              $0005W  #Hard




######################################
########Switch replacement for Lindsey
######################################

#%patch $306EC $0149W #Lindsey Cache start
#%patch $30736 $0149W #Lindsey cache end

#turned off the cache- cause doesnt use any sprites
%patch $EA22 $0000W

#No Lindsey window
%patch $EF83 $E9 $0084W

#sprite actions- made it just 1 frames instead of the usual 4.
%patch $32776 $38EAW #Princess Lindsey 1 #start of action at $3275A

#the sprite-tile interaction- this makes it invisible.
%patch $32772 $00000000L

#Text list
%patch $30848 $1ADCW #Reply 1
%patch $3084A $1B38W #Reply 2


#Keen's replies:
#%patch $309E3 "Hey, this switch controls" $0A
#              "the security gates on Roib." $0A $00
%patch $3094C "The signal in this" $0A
		  "antenna controls" $0A 
		  "the security gates!" $00

%patch $309A8 "Hey, I think this" $0A
              "switch controls the" $0A
		  "security force fields!" $0A $00

#Level where Lindsey gives the Miragia hint instead of the Pyramid one:
%patch $EFB6 $04 $75 
#Level where Keen gives the Miragia reply instead of the Pyramid one:
%patch $F033 $04 $75 


#No 'Lindsey says' text
%patch $EFAA $90 $90 $90 $90 $90

#Level where Lindsey gives the Miragia hint instead of the Pyramid one:
#-makes switch say 'green forcefield' instead
%patch $EFB6 $04 $75

#code for what happens when you touch lindsey
#%patch $CDF9 $9A 45065715 $56 $9A 8B1E850D $83 $C4 $02 $9A 590D1C1D $5F $5E $5D $CB 
#first far call makes messages come up; second far call makes lindsey disappear after you talk to her; third far call clears messages off the screen.

#This makes the level finish after you touch lindsey/switch- BUT! it actually takes over some code which i dont know what it does. so if get some weird glitches, maybe alternatively use next code.
%patch $CE0C $C7 $06 $7A70W  $0002W $5F $5E $5D $CB 

#This also makes the level finish after you touch lindsey, and its not dangerously taking over any code- but the damn thing doesnt work right yet and crashes the game.
#%patch $CDFF $C7 $06 $7A70W  $0002W $5F $5E $5D $CB 



######################################
##########LEVELS
######################################

%patch $2F191 "Exit to Roib" $00

#Allow 24 levels in Keen 4 v1.4:
#First increase the number of levels we can access from the map to maximum (+6)
%patch $DF5D $18 #Number of levels enterable ($18 = 24)
#%patch $8CA4 $18 #Number of level song entries (24, see below)

#Give extra levels valid stuff:
#Level name pointers:
%patch $30764 $1F040000RL #Map
              $1F050000RL #Level 1
              $1F050009RL #Level 2
              $1F060006RL #Level 3
              $1F070001RL #Level 4...
              $1F080001RL #lvl 5
              $1F08000BRL #lvl 6
              $1F090007RL #lvl 7
              $1F0A0004RL #lvl 8
              $1F0A000ERL #lvl 9
              $1F0B000BRL #lvl 10
              $1F0C0008RL #lvl 11
              $1F0D0005RL #lvl 12
              $1F0E0003RL #lvl 13
              $1F0E000ERL #lvl 14
              $1F0F000ARL #lvl 15
              $1F100006RL #lvl 16
              $1F10000BRL #lvl 17
              $1F110000RL #lvl 18
              $1F11000BRL #lvl 19- Hall of fame
              $1F120006RL #lvl 20
              $1F130005RL #lvl 21
              $1F140002RL #lvl 22
              $1F150001RL #lvl 23
              $1F160002RL #lvl 24- BWB Megarocket

%patch $1F040 "Remains of Roib" $00 #0
%patch $1F050 "Boom St." $00 #1
%patch $1F059 "Crashed Ship" $00 #2
%patch $1F066 "Wreck City" $00 #3
%patch $1F071 "Abandoned Tower" $00 #4
%patch $1F081 "The Vault" $00 #5
%patch $1F08B "Sick Forest" $00 #6
%patch $1F097 "Poison River" $00 #7
%patch $1F0A4 "Wasteland" $00 #8
%patch $1F0AE "Yakki Resort" $00 #9
%patch $1F0BB "Border Woods" $00 #10
%patch $1F0C8 "Last Outpost" $00 #11
%patch $1F0D5 "Glass Gardens" $00 #12
%patch $1F0E3 "Gleem City" $00 #13
%patch $1F0EE "Roib Palace" $00 #14
%patch $1F0FA "The Opening" $00 #15
%patch $1F106 "Dump" $00 #16
%patch $1F10B "PLOH" $00 #17
%patch $1F110 "Bug Forest" $00 #18
%patch $1F11B "Scoreboard" $00 #19
%patch $1F126 "Hermit's Shack" $00 #20
%patch $1F135 "Candy Stores" $00 #21
%patch $1F142 "Prophecy Stone" $00 #22
%patch $1F151 "The Bobble Plant" $00 #23
%patch $1F162 "BWB Megarocket" $00 #24


#Level entrance text pointers
%patch $307C8 $1F170001RL #Map
              $1F18000DRL #Level 1
              $1F1A0003RL #Level 2
              $1F1B000FRL #Level 3...
              $1F1D0006RL #lvl 4
              $1F1F0006RL #lvl 5
              $1F210000RL #lvl 6
              $1F22000FRL #lvl 7
              $1F24000BRL #lvl 8
              $1F270000RL #lvl 9
              $1F28000ERL #lvl 10
              $1F2A000ARL #lvl 11
              $1F2C000FRL #lvl 12
              $1F2F0002RL #lvl 13
              $1F30000DRL #lvl 14
              $1F32000CRL #lvl 15
              $1F340004RL #lvl 16
              $1F35000DRL #lvl 17
              $1F360009RL #lvl 18
              $1F380005RL #lvl 19 - Hall of fame
              $1F3A0006RL #lvl 20
              $1F3C0005RL #lvl 21 
              $1F3E000BRL #lvl 22
              $1F410007RL #lvl 23
              $1F43000DRL #lvl 24 - BWB Megarocket

%patch $1F171 "Keen roams around" $0A "the Ruins" $00 #0
%patch $1F18D "Keen crosses" $0A "Boom St." $00 #1
%patch $1F1A3 "Keen flies the" $0A "Crashed Ship" $00 #2
%patch $1F1BF "Keen visits" $0A "Wreck City" $00 #3
%patch $1F1D6 "Keen scales the" $0A "Abandoned Tower" $00 #4
%patch $1F1F6 "Keen drops down" $0A "the Vault" $00 #5
%patch $1F210 "Keen contracts the" $0A "Sick Forest" $00 #6
%patch $1F22F "Keen swims the" $0A "Poison River" $00 #7
%patch $1F24B "Keen needlessly enters" $0A "the Wasteland" $00 #8
%patch $1F270 "Keen resorts to" $0A "...the Resort" $00 #9
%patch $1F28E "Keen nears the" $0A "Border Woods" $00 #10
%patch $1F2AA "Keen finally enters" $0A "the Last Outpost" $00 #11
%patch $1F2CF "Keen breaks into" $0A "the Glass Gardens" $00 #12
%patch $1F2F2 "Keen squints at" $0A "Gleem City" $00 #13
%patch $1F30D "Keen courts the" $0A "Palace of Roib" $00 #14
%patch $1F32C "Keen enters" $0A "the Opening" $00 #15
%patch $1F344 "Keen finds a" $0A "secret Dump" $00 #16
%patch $1F35D "ins.cq" $0A "PLOH" $00 #17
%patch $1F369 "Keen finds a" $0A "forest of bugs" $00 #18
%patch $1F385 "Keen comes across" $0A "the Scoreboard" $00 #19
%patch $1F3A6 "Keen finds some" $0A "hermit's shack" $00 #20
%patch $1F3C5 "Keen finds the" $0A "emergency Candy Stores" $00 #21
%patch $1F3EB "Keen happens across" $0A "the Roib Prophecy Stone" $00 #22
%patch $1F417 "Keen checks out the" $0A "rare Bobble Plant" $00 #23
%patch $1F43D "Keen's Bean-with-Bacon" $0A "Megarocket" $00 #24

#$1F45F -where the text ends

#where it begins to read the above level entry texts
%patch $307C8 $1F170001RL 

#BwB type levels. makes the last 3 levels re-doable
%patch $60FD $15 $77 $5B #Level $xx and above






#######################################
######KEYGEM DOORS
#######################################


#Disable sprite test cheat
%patch $6D39 $CB

#Door tile replacement code, 2x6 block starting at 0,0 in the level
#Door 1, 2x6 at 0,0 in level
%patch $6D3A  $55 $8B $EC $56 $8B $76 $06 $B8 $0006W  $50 $B8 $0002W  $50 $FF     #Block size is here
              $74 $0C $FF $74 $0A $B8 $0000W  $50 $B8 $0000W  $50 $9A $16540D78RL #Block location here
                      $83 $C4 $0C $5E $5D $CB
#Door 2, 2x6 at 0,6 in level
%patch $6D62  $55 $8B $EC $56 $8B $76 $06 $B8 $0006W  $50 $B8 $0002W  $50 $FF     #Block size is here
              $74 $0C $FF $74 $0A $B8 $0006W  $50 $B8 $0000W  $50 $9A $16540D78RL #Block location here
                      $83 $C4 $0C $5E $5D $CB
#Door 3, 2x6 at 0,12 in level
%patch $6D8A  $55 $8B $EC $56 $8B $76 $06 $B8 $0006W  $50 $B8 $0002W  $50 $FF     #Block size is here
              $74 $0C $FF $74 $0A $B8 $000CW  $50 $B8 $0000W  $50 $9A $16540D78RL #Block location here
                      $83 $C4 $0C $5E $5D $CB
#Door 4, 2x6 at 0,18 in level
%patch $6DB2  $55 $8B $EC $56 $8B $76 $06 $B8 $0006W  $50 $B8 $0002W  $50 $FF     #Block size is here
              $74 $0C $FF $74 $0A $B8 $0012W  $50 $B8 $0000W  $50 $9A $16540D78RL #Block location here
                      $83 $C4 $0C $5E $5D $CB

#Door sprite actions:
%patch $3065C $0000W $0000W $0000W $0000W $0000W $000AW $0000W $0000W
              $06BD016ARL   $00000000L    $00000000L    $180AW
%patch $3067A $0000W $0000W $0000W $0000W $0000W $000AW $0000W $0000W
              $06BD0192RL   $00000000L    $00000000L    $1828W
%patch $30698 $0000W $0000W $0000W $0000W $0000W $000AW $0000W $0000W
              $06BD01BARL   $00000000L    $00000000L    $02D7W
%patch $2F147 $0000W $0000W $0000W $0000W $0000W $000AW $0000W $0000W
              $06BD01E2RL   $00000000L    $00000000L    $0000W






#######################################
#########PLATFORMS
######################################

#%patch $1182D $01E9W #Platform moving up left side flame
#%patch $11853 $01E9W #Platform moving up right side flame

%patch $30704 $01E4W #Airboard Cache start
%patch $3074E $01E4W #Airboard cache end


%patch $11822 $10 $FF $90 $90 #turns off the blinking that the flame does on the way down
#patch $1187C $90 $90 $90 $90 #Platform going down flames don't flicker

#Left flame is behind Platforms (Like other flames)
%patch $117F4 $0000W

%patch $1182D $01E9W #Platform moving up left side flame
%patch $11853 $01E9W #Platform moving up right side flame

%patch $11861 $0020W #Moving up right flame h

#%patch $31FDA $01E9W $01E9W
#%patch $31FE4 $0080W

#Moving Platform has no clipping
%patch $114C8 $06 $0000W

%patch $11804 $0050W #Moving left flame v
%patch $117A9 $FF3FW #Moving left flame h
%patch $117A2 $0030W #Moving right flame v
%patch $1180B $0300W #Moving right flame h

#Platforms don't have any flames
%patch $11792 $E9 $3D $01




######################################
########COMMANDER KEEN CHARACTER PATCHES
######################################

#keen's cache
%patch $306D2 $0082W #Keen Cache start
%patch $3071C $00D5W #Keen cache end

#Keen's spawn height
%patch $B833 $FE5FW #15 pixels up- maybe try $FEDFW

#adjusting shot positions when keen shoots
#Keen' shot - Up 
%patch $CA6D $0120W #Vertical position
%patch $CA74 $0078W #Horizontal position
#Right Keen - Right 
%patch $C9B1 $00DCW #Vertical position
%patch $C9B8 $0190W #Horizontal position
#Left Keen - Left 
%patch $C9CD $00DCW #Vertical position
%patch $C9D4 $012CW #Horizontal position
#Keen - Down while jumping 288,128
%patch $CA2D $0190W #Vertical position
%patch $CA34 $00E6W #Horizontal position
#Keen - Up while jumping 
%patch $CA4D $00A0W #Vertical position
%patch $CA54 $00ADW #Horizontal position
#Right Keen - Right on poles 
%patch $CA94 $0040W #Vertical position
%patch $CA9B $0140W #Horizontal position
#Left Keen - Down on poles
%patch $CB35 $01F4W #Vertical position
%patch $CB3C $0140W #Horizontal position
#Right Keen - Down on poles
%patch $CB18 $01F4W #Vertical position
%patch $CB1F $0000W #Horizontal position
#Right Keen - Up on poles
%patch $CAD6 $FFF5W #Vertical position
%patch $CADD $0000W #Horizontal position
#Left Keen - Up on poles
%patch $CAF1 $FFF5W #Vertical position
%patch $CAF8 $012CW #Horizontal position
#Right Keen - Jumping Right
%patch $C9F4 $0060W #Vertical position
%patch $C9FB $0140W #Horizontal position
#Left Keen - Left 32,0
%patch $CA10 $0060W #Vertical position

#Keen's shot's foreground value
%patch $E5A1 $0001W

#Keen's new 'bored' anims
%patch $2F838 $0094W $0094W $0003W $0000W $0001W $006EW $0000W $0000W 
		  $0B80045CRL $0B8014A9RL   $0B801AA2RL   $09E6W   #holding bottle

%patch $2F856 $0093W $0093W $0003W $0000W $0001W $0028W $0000W $0000W 
		  $0B80045CRL $0B8014A9RL   $0B801AA2RL   $09C8W	#drinking from bottle

#this fixes up keen's getting-up-from-reading anim (takes it out almost)
%patch $2FA18 $0093W $0093W
%patch $2FA34 $098CW

#makes keen's sliding down pole just 1 frame
%patch $2FDF6 $00B7W $00B7W
%patch $2FE12 $0F86W

#the images for picking point items up
%patch $30284 $0099W #100
%patch $30286 $009AW #200
%patch $30288 $009BW #500
%patch $3028A $009CW #1000
%patch $3028C $009DW #2000
%patch $3028E $009EW #5000
%patch $30290 $009FW #1-Up
%patch $30292 $00B8W #gun

#where the flower gettin' images are at
%patch $30DB6 $0095W $0095W
%patch $30DD4 $0096W $0096W
%patch $30DF2 $0097W $0097W

#%patch $1BF95 $0095W

#keen climbing over edges
#%patch $301A2 $001EW
#%patch $301C0 $001EW
%patch $301FC $0028W

#new sprite positions for some of the pogoing frames
%patch $2FFB8 $00B9W
%patch $2FF9A $00BAW
%patch $2FF7C $00BAW

#this adjusts the height that keen spawns at when he exits a door
%patch $C07B $01A9W

#this makes keen jump normally when in easy mode
%patch $C3E7 $90 $90
#this makes keen pogo normally when in easy mode
%patch $C55C $90 $90

#one of keen's dying frames- made one of em a jumping frame
%patch $2FB80 $0089W $0089W

#moved around the first keen pogoing right frame
%patch $2FFB8 $00A3W

#moved around the second keen pogoing right frame
%patch $2FF7C $0098W
%patch $2FF9A $0098W




#####################################
##########King Gak replacement for Oracle Janitor
####################################

#'hard down dart' pointer
%patch $EF2D $043DW

%patch $ED2D $FF $76 $FC $57 $9A $0D8F07ABRL $83 $C4 $04 $C7 $06 $5D $CB
             $0001W  $E9 $00BBW

#overtaking 'Keen on foot for map' behaviour code- $0D8F07ABRL 
%patch $E09B $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0006W  $C7 $47 $02 $0001W  $8B $46 $06 $B1 $08
              $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C
              $B8 $25B2W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $31422 $0164W $0164W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE742D0RL $00000000L $25B2W

#give king gak/oracle janitor a collision to reset level 15 as undone. - $2EE742D0RL
#this is cause of some annoying crap that has to with the bridges on the map being opened up 
#when level 15 is complete (have no choice) but then makes level 15 (boss level) unplayable, so i had to put some code somewhere 
#(preferably at the end of level 14, which is perfect here) that resets level 15 back as undone, so you can actually play the last level.
%patch $33140 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $06
              $C7 $06 $7A3CW $0000W $5F $5E $8B $E5 $5D $CB

 
%patch $F113 $000BW  #Height
%patch $F146 $1F47RW #Text read from 1
%patch $F123 $0072W  #Bitmap displayed

#%patch $1F580
%patch $1F470 "King Gak:" $0A $0A
		  "Senor Keen! Oh my god!" $0A
              "You're here! Please" $0A
		  "stop them! They're all" $0A 
		  "over the place!" $0A
              "Please save me!" $00

#Janitor window 2
%patch $F184 $000BW  #Height
%patch $F188 $001AW  #Width
%patch $F1DF $003CW  #Time displayed
%patch $F194 $006FW  #Bitmap displayed + 6 (Show BMP 105)
%patch $F1B7 $1F4ERW #Text read from 1
%patch $F1BB $0000W  #2

%patch $1F4E0 " " $0A $0A
		  "Okay okay. Calm down." $0A
              "Yeesh.     " $00

#Janitor window 3
%patch $F1F5 $000BW  #Height
%patch $F1F9 $001AW  #Width
%patch $F252 $003CW  #Time displayed
%patch $F205 $0072W  #Bitmap displayed + 6 (Show BMP 104)
%patch $F22A $1F51RW #Text read from 1
%patch $F22E $0000W  #2

%patch $1F510 " " $0A
		  "Theres some sort of " $0A
              "opening to the north" $0A
		  "of here. It appeared" $0A
              "just before the" $0A
		  "attack." $00

#Janitor window 4
%patch $F268 $000BW  #Height
%patch $F26C $001AW  #Width
%patch $F2C3 $003CW  #Time displayed
%patch $F278 $006FW  #Bitmap displayed + 6 (Show BMP 105)
%patch $F29B $1F58RW #Text read from 1
%patch $F29F $0000W  #2

#Text
%patch $1F580 " " $0A $0A
		  "Alright I'll go" $0A
              "have a look." $00

#Remove the last window (Keen's stare)
%patch $F2D8 $EB $62

#Bitmap cache (3 bitmaps, 104,5 and 7)
%patch $F0E6 $0072W 

#Don't change music when talking to Oracle janitor
%patch $F10A $90 $90 $90 $90 $90



######################################
##########YAKKI REPLACEMENT FOR COUNCIL MEMBERS
######################################

##making each Yakki on the map give a different message- did this by making touching the yakki not really increment the council count game stat- but rather each yakki's (each different) collision code forces 
##the council member resuced game stat to be numbered whatever i want, which corroborates with whatever message that yakki gives. 

###SPRITES-

#cache
%patch $306F2 $0164W #Council Member Cache start
%patch $3073C $0165W #Council member cache end


####YAKKI 1

#sprite type
%patch $FCFD  $05

#clipping
%patch $FD01 $06 $0000W

#making member use 2 frames
%patch $30E28 $0164W $0164W $0003W $0000W $0000W $000AW $0000W $0000W
%patch $30E38 $00000000L $2EE73F26RL $09DC176ERL $1FD6W    
%patch $30E46 $0165W $0165W $0003W $0000W $0000W $000AW $0000W $0000W
%patch $30E56 $00000000L $2EE73F26RL $09DC176ERL $1FB8W   

#Council man collision; if Keen run oracle windows and transform
#currently = $2EE73F26RL
%patch $32D96 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $15
              $C7 $44 $1C $3944W $C7 $06 $7A5EW $0000W $9A $0E8F0BA5RL     $9A $16540D59RL   $5F
              $5E $8B $E5 $5D $CB

#$3944W- this is what the yakki talking balloons turn into after you talk to them- seemed to stop the game from crashing after talking to them.
%patch $327B4 $FFFFW $FFFFW $0003W $0000W $0000W $0005W $0000W $0000W
		  $00000000L $00000000L $09DC176ERL    $3944W



####YAKKI 2

#pointer location for level editor- 'hard left dart'
%patch $EF2F $0E46W #got the last value by F736-E8F0 (the latter num being the start of the sprite spawn segment)

#initiation code - getting the last value is: F74C (value of last local in this code) - EDFD(B block code) = x; 100,000 - x = y. and y is what you're after.- i think thats wrong actually
%patch $F736 $FF $76 $FC $57 $9A $108007EDRL $83 $C4 $04 $C7 $06 $5D $CB
             $0001W  $E9 $F6B2W

#sprite spawning code- overtaking some of the inchworm collision
%patch $10FED $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W  $C7 $47 $06 $0000W  $8B $46 $06 $B1 $08
              $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C
              $B8 $24FEW  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $3136E $0164W $0164W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE73F52RL $09DC176ERL $251CW
%patch $3138C $0165W $0165W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE73F52RL $09DC176ERL $24FEW

##Yakki 2 collision- $2EE73F52RL
%patch $32DC2 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $0F
              $C7 $44 $1C $3944W $C7 $06 $7A5EW $0001W $9A $0E8F0BA5RL     $9A $16540D59RL   $5F
              $5E $8B $E5 $5D $CB



####YAKKI 3

#'medium dopefish' pointer
%patch $EF31 $0E5CW

%patch $F74C $FF $76 $FC $57 $9A $11A20079RL $83 $C4 $04 $C7 $06 $5D $CB
             $0001W  $E9 $F69CW

#using the 'move up to get items' smirky behaviour - 
%patch $11A99 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W  $C7 $47 $06 $0000W  $8B $46 $06 $B1 $08
              $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C
              $B8 $253AW  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $313AA $0164W $0164W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE73F7ERL $09DC176ERL $2558W
%patch $313C8 $0165W $0165W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE73F7ERL $09DC176ERL $253AW

#Yakki 3 collision- $2EE73F7ERL
%patch $32DEE $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $0F
              $C7 $44 $1C $3944W $C7 $06 $7A5EW $0002W $9A $0E8F0BA5RL     $9A $16540D59RL   $5F
              $5E $8B $E5 $5D $CB



####YAKKI 4

#'hard dopefish' pointer
%patch $EF33 $0E72W

%patch $F762 $FF $76 $FC $57 $9A $10800844RL $83 $C4 $04 $C7 $06 $5D $CB
             $0001W  $E9 $F686W

%patch $1106E $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0005W  $C7 $47 $06 $0000W  $8B $46 $06 $B1 $08
              $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C
              $B8 $2576W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

%patch $313E6 $0164W $0164W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE73FAARL $09DC176ERL $2594W
%patch $31404 $0165W $0165W $0003W $0000W $0000W $000AW $0000W $0000W
		  $00000000L $2EE73FAARL $09DC176ERL $2576W

#Yakki 4 collision
%patch $32E1A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $0F
              $C7 $44 $1C $3944W $C7 $06 $7A5EW $0003W $9A $0E8F0BA5RL     $9A $16540D59RL   $5F
              $5E $8B $E5 $5D $CB

#sizes-
#22- initiation code
#64- spawn code
#44- collision code


###MESSAGES-


#Disable Council Member message window
%patch $F52E $90 $90 $90 $90 $90
%patch $F544 $90 $90 $90 $90 $90
%patch $F534 $0004W

#don't play second sound when encountering yakki
%patch $CDAF $90 $90 $90 $90 $90 

#Change bitmap when window displayed
%patch $F4AE $006EW #Cache Council Member graphic
%patch $F55A $006EW #Bitmap displayed (35)

#position of yakki pic
%patch $F569 $0030W

#Height of message box
%patch $F54A $000BW 

#Replies pointer list
%patch $3084C $1C01W #First reply
              $1C51W #Second reply
              $1CC3W #Third...
              $1D19W #4
    

#Yakki messages:
%patch $30A71 "Yakki Bok:" $0A $0A
              "Captain Keen! You got" $0A
		  "here too late. Its" $0A 
		  "over. Roib is finished" $00

%patch $30AC1 "Yakki Kak:" $0A $0A
              "General Keen! When" $0A
		  "the attack began" $0A
		  "we put our defences" $0A
		  "up around Roid. Sorry," $0A
		  "they're in the way." $00

%patch $30B33 "Yakki Yab:" $0A $0A
              "Collator Keen, why" $0A
		  "did the invaders" $0A
		  "destroy our lovely" $0A
              "forests? What for?" $00

%patch $30B89 "Yakki Dok:" $0A $0A
		  "Fuhrer Keen! Just" $0A
		  "north, rich Upper Roib" $0A
		  "was shielded in the" $0A
		  "attack by cool sci-fi" $0A
		  "domes." $00


#Disable member windows (Fix this, it is code!) Add window clear
%patch $6ADD $9A $0E8F0BA5RL

#This makes talking to the Yakki mark something set to 0 I think. i forget what this is about.
%patch $F5E0 $7A5EW
#%patch $6B07 $0000W
#%patch $6BAC $0000W
#%patch $7E7C $0000W
#%patch $9139 $0000W

#Completely disable Council Member messages- turned it off- wasnt sure what difference it made
%patch $CD93 $13

#%patch $F5D4 $5F $5E $8B $E5 $5D $CB


####Map keen

#this makes map keen able to talk to council members (just changed its collision)
%patch $30352 $0B8014A9RL
%patch $30370 $0B8014A9RL
%patch $3038E $0B8014A9RL
%patch $303AC $0B8014A9RL
%patch $303CA $0B8014A9RL
%patch $303E8 $0B8014A9RL
%patch $30406 $0B8014A9RL
%patch $30424 $0B8014A9RL







######################################
###########MUSIC
######################################

%patch $8CCD $96 $03 #$2F206

#Change number of songs:
#%patch $8CEF $9B $00
#%patch $8C75 $C891W
#%patch $8C83 $C891W
#%patch $8D83 $C891W

%patch $8CA4 $19 #Number of level song entries (24)- the example on the wiki should be 19 not 18.

%patch $2F206 $04 $00 #Map 0
              $08 $00 #Boom St. 1
              $07 $00 #Ship 2
              $06 $00 #Wreck City 3
              $05 $00 #Abandoned Tower 4
              $07 $00 #The Vault 5
              $00 $00 #Sick Forest 6
              $00 $00 #Poison River 7
              $05 $00 #Wasteland 8
              $06 $00 #Resort 9
              $07 $00 #Border Woods 10
              $01 $00 #Last Outpost 11
              $05 $00 #Glass Gardens 12
              $06 $00 #Gleem City 13
              $01 $00 #Palace of Roib 14
              $03 $00 #The Opening 15
              $08 $00 #secret 16
              $09 $00 #secret 17
              $08 $00 #secret 18
              $04 $00 #High scores 19
		  $09 $00 #secret 20
		  $08 $00 #secret 21
		  $02 $00 #Prophecy Stone
		  $02 $00 #Bobble Plant
		  $02 $00 #BWB Megarocket
		  

%patch $5836 $02 $00 #Story demo (lvl 2)
%patch $9CD7 $0F $00 #Ending Sequence (lvl 15/boss music)
#%patch $F107 $FF $FF #Talking to Lindsey (Ancient)
#%patch $F4CA $FF $FF #Talking to Ancient (Ancient)

#Music names:
#00= '1066'
#01= ??
#02= 'Cool Blue'
#03= ??
#04= '993'
#05= 'Keem_312'
#06= 'Glorgy's'
#07= 'Here'
#08= 'MattCool'


#Add new music
#Index of first music chunk within audio chunks:
%patch $8CEF $0098W # 98 is hex for 152- the number of the first song in my list.txt. originally $009CW

#Start address of music chunks
#reduce start address by 2x that of "First Audio Entry"
%patch $8C75 $C88DW # clear_music()- originally C895W
%patch $8C83 $C88DW # clear_music()
%patch $8D83 $C88DW # StartMusic()
%patch $8C91 10      # Total Number of Songs

#Play music in the menu
%patch $1CC6F $06BD20C7RL
%patch $1CC6B $0018W      #Play this level's song

#Ending sequence has same music as last level
%patch $F4CD $90 $90 $90 $90 $90 #Don't change music for member
%patch $F5E7 $90 $90 $90 $90 $90 #Don't change music after member rescued
#%patch $9CDA $90 $90 $90 $90 $90 #Don't play E.S. music




################################################
############STATUS WINDOW
################################################

%patch $800C $00A6W #Vertical
%patch $8012 $0080W #Horizontal
%patch $2F4CB "FLOWERS" $00

#Don't draw wetsuit stuff
%patch $806C $90 $90 $90 $90 $90 #Background rectangle
%patch $8091 $90 $90 $90 $90 $90 #If got wetsuit
%patch $809F $90 $90 $90 $90 $90 #If not got wetsuit

#'Press Any Key' pic position
%patch $80BE $0078W #Horizontal position
%patch $80DC $0078W #Horizontal position

#Don't draw members
%patch $7E32 $90 $90 $90 $90 $90 #Rescued text
%patch $7E4D $90 $90 $90 $90 $90 #Background rectangle
%patch $7E6D $90 $90 $90 $90 $90 #Rescued tiles

#what number of councilmen pics represents in the 'resuced' box. thought about having medals come up from reading the mooning variable or something
#%patch $7E7C $7A52W

#Gems- text
%patch $7F0C $0062W #Vertical
%patch $7F12 $0055W #Horizontal
%patch $7F15 $064BW #Text read from
%patch $2F4BB "GEMS" $00 
#Background rectangle
%patch $7F24 $000AW #Height
%patch $7F28 $0022W #Width
%patch $7F2C $005FW #Vertical position
%patch $7F30 $005FW #Horizontal position
#Gem counter
%patch $7F45 $7A60W $00 $74 #What to track (Red to green gem, draw if <>0)
%patch $7F4D $0024W #Start tile
%patch $7F51 $0060W #Vertical position
%patch $7F5D $0066W #Horizontal position




######################################
###########Beserky Robot replacement for slug
#####################################

#Cache- made it cache less frames; dont need them
%patch $306E6 $013BW #Slug Cache start
%patch $30730 $013FW #Slug cache end

#Stunned slug
%patch $30EDC $013DW $013DW #'Tall' slug
#%patch $30EE6 $0000W        #Animation speed
%patch $30EFA $013DW $013DW #'Short' slug
#%patch $30F04 $0000W        #Animation speed

#Poison slug crawl
%patch $30E82 $013EW $013BW
#%patch $30E8C $0008W        #Animation speed
%patch $30EA0 $013FW $013CW
#%patch $30EAA $0008W        #Animation speed

#smoother animation??
%patch $30E86 $0003W #Crawl 1
%patch $30EA4 $0003W #Crawl 2

#Speed
%patch $30E8E $40 $10 #Speed 1
%patch $30EAC $40 $10 #Speed 2
#%patch $FEB3  $E8 $FF #Jump when shot height

#Slugs don't move h/v when shot- maybe useful if robot stands still and deactivated after being hit.
#[Remove 4 90s to make them move very little]
#%patch $FEB8 $90 $90 $90 $90 $90 $90

#'motion'
%patch $30E86 $01 $00 #Poison slug 1 [Sit]-keep these two on to make animation smooth.
%patch $30EA4 $01 $00 #Poison slug 2 [Sit]


###Randomness- disable the poisoning
#Spawn moving right or left
#%patch $FDB9 $80
#Sliming frequency
%patch $FDF6 $00
#Probbability of shot slug being 'small'
#%patch $FE8E $80

#animate twice as fast, only 1.5 times faster
%patch $30E8E $18 $00 $00 $00 #Speed 1 [Orig 40 = 3/4]- keep these two on to slow down what i did with 'motion'
%patch $30EAC $18 $00 $00 $00 #Speed 2 [Orig 40 = 3/4]
%patch $30E8C $11 $00 #Anim speed [Orig 8 = 1/2 = twice as fast][From sec 7.)]
%patch $30EAA $11 $00 #Anim speed [2* 3/4 = 1.5]

#Slug collision produces only one type of slug
%patch $FE6A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
         $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type 3)
         $206CW  $50 $57 $56 $9A $09DC1695RL    $83 $C4 $06 $C7 $44 $18     #If shot, become $206C
         $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D  #Jump into the air $FFE8
             $CB

#Spawn height
%patch $FDAE $FFFFW #7 pixels up






#############################################
#########Fliphead replacement for Arachnut
#############################################

#cache end
%patch $30746 $01ACW

#walking
%patch $311E8 $01A9W $01ACW $0003W $0000W $0001W $0008W $0025W $0000W
%patch $311F8 $00000000L    $0FA80B1CRL $09DC1795RL $2378W

#flipping when shot- $2396W
%patch $31206 $01AAW $01AAW $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $23B4W
%patch $31224 $01ABW $01ABW $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $23D2W
%patch $31242 $01ACW $01ACW $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $23F0W
%patch $31260 $01A9W $01A9W $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $240EW
%patch $3127E $01AAW $01AAW $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $242CW
%patch $3129C $01ABW $01ABW $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $244AW
%patch $312BA $01ACW $01ACW $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $2468W
%patch $312D8 $01A9W $01A9W $0000W $0000W $0001W $0008W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $2210W
#overtaking these from bluebird sprite actions
%patch $31080 $01AAW $01AAW $0000W $0000W $0001W $0010W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $222EW
%patch $3109E $01ABW $01ABW $0000W $0000W $0001W $0014W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $226AW
%patch $310DA $01ACW $01ACW $0000W $0000W $0001W $0018W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $2288W
%patch $310F8 $01A9W $01A9W $0000W $0000W $0001W $0024W $0000W $0000W
		  $00000000L    $00000000L    $09DC176ERL  $2378W

#Stun to new cycle
%patch $105A9 $2396W #When shot, stun
%patch $105D5 $2396W #When shot while stunned, stun again





#############################################
########PATCHES FROM LEVELLASS FROM INTERNET- SLUG AND ARACHNUT PATCHES
############################################

#Disable EGAGRAPH check in Keen 4 (Frees 389 bytes at $3CF6)
%patch $3CE5 $90 $90
 
#New slug movement behavior 'random movement'
%patch $3CF6 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $76 $06 $9A $1D02002ARL
                     $3D $0064W  $7D $08 $C7 $44 $0E $FFFFW  $5E $5D $CB $C7    #Robability of switch is $0040W
              $44 $0E $0001W  $5E $5D $CB

#Slug uses new behavior
%patch $30E92 $037D0526RL
%patch $30EB0 $037D0526RL






#######################################################
########DRONE REPLACEMENT FOR SKYPEST 
####################################################

#Skypest caching- made it cache less sprites than normal, cause im only using a few.
%patch $306FE $01BBW #Skypest Cache start
%patch $30748 $01BEW #Skypest cache end

#Skypest flying
%patch $312F6 $01BBW $01BBW
%patch $31300 $0010W        #Animation speed
%patch $31314 $01BCW $01BCW
%patch $3131E $0010W        #Animation speed

#can't be squished
%patch $10738 $90 $90 $90

#New collision for Skypest, stunnable
%patch $3D1D $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
         $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $1F $B8     #If Keen, kill him; check for shot (Type3)
         $24C2W  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $C7 $44 $18     #If shot, become $24C2W
         $FFE8W  $8B $44 $0E $D1 $E0 $D1 $E0 $D1 $E0 $89 $44 $16 $5F $5E $5D #Jump into the air $FFE8
             $CB

#new sprite tile interac- turns falling drone into smashed drone on ground- $037D058FRL
%patch $3D5F $55 $8B $EC $56 $8B $76 $06 $83 $7C $38 $00 $75 $06 $83 $7C 
		 $3C $00 $74 $05 $C7 $44 $16 $0000W $C7 $44 $20 $0000W $83 $7C $36 $00 $74 $19 
		 $B8 $000BW $50 $9A $187409F1RL $83 $C4 $02 $B8 $24E0W
		 $50 $56 $9A $09DC120ARL $83 $C4 $04 $FF $74 $20 $33 $C0 
		 $50 $FF $74 $1E $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 
		 $50 $9A $16541641RL $83 $C4 $0C $5E $5D $CB


#Skypests use new collision
%patch $3130A $037D054DRL #Flying skypest
%patch $31328 $037D054DRL #Flying skypest

#Stunned skypests act properly
%patch $31332 $01BDW $01BDW $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $037D058FRL $24E0W 

%patch $31350 $01BEW $01BEW $0000W $0000W $0000W $0000W $0000W $0000W
              $00000000L  $00000000L    $09DC176ERL    $24E0W 


#Skypests don't land
%patch $107BA $2486W #Skypest preening

#Flying- behaviours- makes it follow keen
%patch $31306 $11A20711RL #Skypest flying
%patch $31324 $11A20711RL #Skypest flying

#Flying
%patch $31302 $0048W $0000W #Speed 1
%patch $31320 $0048W $0000W #Speed 2

#Flying- action type
%patch $312FA $0003W #Skypest flying 1
%patch $31318 $0003W #Skypest flying 2

#Flying speeds
%patch $106B5 $0032W #Speed l/r
%patch $106C5 $0032W #Speed u/d

#Randomly change direction to down\right when flying
%patch $10695 $0032W

#Flying- behaviours- makes it fly towards Keen
%patch $31306 $11A20AF6RL #Skypest flying
%patch $31324 $11A20AF6RL #Skypest flying

#Skypest preening
%patch $31350 $01BEW $01BEW 
%patch $3135A $0064W        #Pause before eye-lick





################################################
#########JUNKBALL REPLACEMENT FOR UNDERWATER MINE
###################################################

#Underwater Mines sprite type
#%patch $12720 $0F #Mines placed in level

#Mine Foreground variable
%patch $1272A $0001W

#added the 2 exploding frames and add them to movement anim- btw it was the very last value i had to screw with to make it animate as it moved- it dictates what comes next.
#note: having those 3 values be 0000W makes it move correctly
%patch $3271E $01B8W $01B8W $0003W $0000W $0000W $0016W $0000W $0000W
              $0FA80BE7RL $0FA80C57RL    $1080097ERL    $38CCW 
%patch $3273C $01B9W $01B9W $0003W $0000W $0000W $0016W $0000W $0000W
              $0FA80BE7RL $0FA80C57RL    $1080097ERL    $3890W 
%patch $32700 $01BAW $01BAW $0003W $0000W $0000W $0016W $0000W $0000W
              $0FA80BE7RL $0FA80C57RL    $1080097ERL    $38AEW 

#$2DAAW
%patch $31C1A $01BAW $01BAW $0003W $0000W $0000W $0016W $0000W $0000W
              $0FA80CF1RL $0FA80C57RL    $0FA804ECRL    $38AEW 

#i *think* this controls the speed of the ball (if it does, then it doesnt do it all too much)
#%patch $111BC $F110W
#%patch $11260 $0005W

#skypest flying up from ground speed?
#%patch $10780 $FFFFW

#speed?
#%patch $111C7 $0040W
#%patch $111D1 $0000W

#in the bounder sprite-tile check code- it now produces junkball when it bounces
%patch $11221 $2DAAW
%patch $1126E $2DAAW
%patch $1127D $2DAAW

#this controls the speed of how fast the junkball bounces off the ground
%patch $10786 $D0

#%patch $FF9C $FFF0W

#so, has the bounder's bounce tile interac. but when it hits the ground ground, goes to another sprite action that has the skypest flying up off ground behaviour. had to do it like this to make it work right.

%patch $11192 $0032W

#Moving Mine
%patch $3271C $38AEW 

#Underwater Mines placed in-level
%patch $1278C $38AEW 

#how far it moves when you shoot it
#horizontal:
%patch $106FA $0032W
%patch $10714 $0032W
#vertical:
%patch $10707 $F12CW
%patch $10721 $F12CW

#%patch $10B08 $0000W
#%patch $10B0A $C7 $47 $10 $FFFFW

#Flying speeds
%patch $106B5 $000AW #Speed l/r
%patch $106C5 $000AW #Speed u/d

#When hitting floors\ceilings
#%patch $10780 $FFF0W #Speed up of Pest when it flies off ground
%patch $1079B $000AW #Speed down of Pest when hits ceiling




################################################
############ROACH REPLACEMENT FOR INCHWORM
################################################

#Inchworm sprite type
#%patch $10EC6 $01

#inchworm initiation code- the original one was caching a bunch of stuff i dont need
%patch $EABD $FF $76 $FC $57 $9A $108006B2RL     $83 $C4 $04 $C7 $06 $59 $CB
             $0001W  $E9 $0329W

#Cache (originally it also caches the smoke and foot, so dont need em)
%patch $306EE $014DW #Inchworm Cache start
%patch $30738 $0150W #Inchworm cache end

#Foreground- so its infront of everything (cause its legs were being cut off by the tiles it walked on)
%patch $10ED0 $0002W #Inchworm

#Inchworm behavior code- makes them run away from keen
%patch $10F70 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $1E $D6 $A7 $3B $47
              $0A $76 $08 $C7 $44 $0E $0001W  $5E $5D $CB $C7 $44 $0E $FFFFW   
              $5E $5D $CB

%patch $31D16 $00090W $0001W #Speed 1
%patch $31D34 $00090W $0001W #Speed 2

%patch $31D0A $014FW $014DW #Inchworm 1
%patch $31D14 $000AW        #Animation speed
%patch $31D28 $0150W $014EW #Inchworm 2
%patch $31D32 $000AW        #Animation speed




#Inchworms- collision
%patch $31D1E $00000000L #Inchworm 1
%patch $31D3C $00000000L #Inchworm 2

#Inchworms- sprite-tile interaction
%patch $31D22 $09DC1795RL    #Walk back and forth
%patch $31D40 $09DC1795RL    #Walk back and forth






#################################################
#########VERTICAL ROACH, new 'enemy' from scratch
###################################################

#Sprites use new initiation code- uses the 'I keen' tile
%patch $EECB $0E17W # 'I Keen' (At $F707)

#New initiation code- from Inchworm- using the Keen swimming behaviour, ripped off from levellass's example
%patch $F707 $FF $76 $FC $57 $9A $0E8F0E46RL $83 $C4 $04 $C7 $06 $59 $CB
             $0001W  $BE $5E $01 $EB $0F $B8 $3A $2A $8A $16 $EC $7A $8E $C0
             $26 $08 $94 $00 $00 $46 $81 $FE $61 $01 $76 $EB $E9 $F3B3W 

#Note: last value has to skip to the B sprite initiation code (which is at $EDFD), so its EDFD minus what the next code location is *after* this last value

#Note: in the cache list on its wiki/web page, the leftmost value (memory location) 'cache start' value differs to its neighbour's by 2.

#Note about segment 'long call' code: if you round down the segment, you have to add what you rounded down to the difference at the end when you put it together into the one code

#platform spawn code- comes after the above code (by counting all groups of numbers, then counting 2 for every XXXXW and 4 for every XXXXXXXXRL)
#WARNING- Im using $F736 for something else- find another spot for this
#%patch $F736  $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
#              $D8 $A7 $C7 $07 $0010W  $C7 $47 $02 $0002W  $C7 $47 $20 $0000W
#              $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89
#              $47 $3E $89 $47 $0C $C7 $47 $0E $0000W  $C7 $47 $10 $0001W  $C7
#              $47 $06 $0000W  $B8 $016AW  $50 $53 $9A $09DC118CRL     $83 $C4
#              $04 $5D $CB

%patch $2EFDA $014DW $014EW $0003W $0000W $0000W $0008W $0000W $0020W
              $10801182RL $00000000L  	$09DC176ERL    $016AW  
%patch $2EFF8 $014EW $014DW $0003W $0000W $0000W $0008W $0000W $FF20W
              $108011FBRL $00000000L  	$09DC176ERL    $0188W  

#%patch $11982 #where the rising platform behaviour code starts

#rising platform sprite
#%patch $119F3 $0188W 

#01E4= platform sprite




#New behavior = $0E8F0E99RL (from 108011FBRL)
%patch $F789  $55 $8B $EC $56 $8B $76 $06 $39 $36 $6E $7A $75 $0D $C7 $44 $18 
		  $0000W  $C7 $44 $1C $016AW  $5E $5D $CB

#something to do with falling/rising platforms ($1080120FRL)
%patch $11A15 $8B $44 $0C $3B $44 $3E $77 $0E $8B $44 $3E $2B $44 $0C $A3 $21 
		  $C9 $C7 $44 $1C $3188W  $5E $5D $CB

#New behaviour
#%patch $F7A3  $55 $8B $EC $56 $8B $76 $06 $39 $36 $6E $7A $75 $23 $A1 $4C $A5
#		  $B1 $04 $D3 $E0 $A3 $21 $C9 $C7 $44 $0E $0000W  $8B $44 $0C $03 
#		  $06 $21 $C9 $2B $44 $3E $3D $80 $00 $72 $05 $C7 $44 $1C $016AW 
#		  $5E $5D $CB


#%patch $F789  $55 $8B $EC $83 $EC $04 $56 $57 $8B $7E $06 $8B $45 $0E $BA $0C 
#		  $00 $F7 $EA $F7 $2E $4C $A5 $A3 $23 $C9 $8B $45 $10 $BA $0C $00 
#		  $F7 $EA $F7 $2E $4C $A5 $A3 $21 $C9 $83 $7D $0E $01 $75 $5E $8B 
#		  $45 $26 $03 $06 $23 $C9 $89 $46 $FE $B1 $08 $D3 $E8 $89 $46 $FC 
#		  $8B $45 $30 $3B $46 $FC $75 $03 $E9 $C1 $01 $8B $5D $2E $D1 $E3 
#		  $8B $9F $25 $C9 $D1 $EB $D1 $E3 $8E $06 $EB $A7 $8B $46 $FC $D1 
#		  $E0 $03 $D8 $26 $83 $3F $1F $74 $03 $E9 $A0 $01 $C7 $45 $0E 
#		  $FFFFW $8B $46 $FE $25 $FF $00 $8B $16 $23 $C9 $2B $D0 $89 $16 
#		  $23 $C9 $5F $5E $8B $E5 $5D $CB






##################################################
########CONSOL ITEM, WHICH WINS THE GAME- OVERTAKING THE FOOT'S PLACE
##################################################

#Overtaking foot initiation code, and other foot stuff
#item
%patch $EA8E $FF $76 $FC $57 $9A $1080072CRL     $83 $C4 $04 $C7 $06 $63 $CB
             $0001W  $BE $5E $01 $EB $0F $B8 $3A $2A $8A $16 $EC $7A $8E $C0
             $26 $08 $94 $00 $00 $46 $81 $FE $61 $01 $76 $EB $E9 $0340W

#taking over Foot spawning code (its at $1080072CRL)
%patch $10F2C $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0000W  $C7 $47 $20 $0003W  $8B $46 $06 $B1 $08
              $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05 $FF00W  $89 $47 $0C
              $B8 $1492W  $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB

#Sprite actions- overtaking map keen on foot actions
%patch $30302 $01A4W $01A4W $0002W $0000W $0000W $0000W $0000W $0000W 
		  $00000000L $2EE742EDRL $09DC176ERL    $1492W 

#this collision sets the level state to 13 which wins the game, from levellass. - $2EE742EDRL
%patch $3315D $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $C6 $4C $83 $3D
              $02 $75 $06 $C7 $06 $7A70W  $000DW $5F $5E $5D $CB #$EB $7E

#State 13 wins game
%patch $6BD9 $0EB2W
   

#far call for end game code in that oracle code- $9A $05C40EB2RL




#################################################
##########ROBO WRECK REPLACEMENT FOR BOUNDER
#################################################

%patch $30706 $01EFW #Bounder Cache start
%patch $30750 $01EFW #Bounder cache end

#Spawn height:
%patch $1111A $FF0FW

#Bouncing vertically
%patch $31D82 $01EFW $01EFW 
%patch $31D8C $0028W        #Animation speed
%patch $31DA0 $01EFW $01EFW $0000W $0000W $0000W $0000W $0000W $0000W
%patch $31DAA $0007W        #Animation speed

#How high a bounder flies into the air when shot
#%patch $11179 $20

#Bounder- sprite-tile interaction
%patch $31D9A $09DC176ERL    	
%patch $31DB8 $0FA8097FRL    		
%patch $31DD6 $09DC176ERL    	
%patch $31DF4 $0FA8097FRL    

#Bounder- Action type (+14 more than sprite-tile interac.)
%patch $31DA8 $0000W 
%patch $31DC6 $0000W 	
%patch $31DE4 $0000W 	
%patch $31E02 $0000W 
#%patch $31E20 $0003W #stunned   
#%patch $31E3E $0003W #stunned   

#Bounder bouncing- behaviours
%patch $31D92 $09DC16E5RL 
#%patch $31DB0 $09DC1701RL 
%patch $31DCE $09DC16E5RL 
#%patch $31DEC $09DC1701RL 

#Bounder- collision
%patch $31D96 $10800793RL    	#Bounder vertical
%patch $31DB4 $10800793RL    	#Bounder vertical
#%patch $31DD2 $0FA80C57RL 	#Bounder left\right
#%patch $31DF0 $0FA80C57RL 	#Bounder left\right

#Bounder bouncing- deprotect and stick to ground- somehow different to the one above
%patch $31D88 $0000W $0000W
%patch $31DA6 $0000W $0000W
%patch $31DC4 $0000W $0000W
%patch $31DE2 $0000W $0000W

#Bounder sprite type
#%patch $110FE $03 #When spawned
#%patch $11174 $21 #When stunned

#Stunned- collision
#%patch $31E0E $0FA80C57RL    #No collision (In air)
#%patch $31E2C $0FA80C57RL    #No collision (On ground)

#Bounder's foreground
%patch $11108 $0002W

#Bounder collision - taking over inchworm collision- original mem location was at $11138
%patch $10F93 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $3C $00 $75 $05
              $9A $0B8013E9RL     $83 $3C $03 $75 $3B $83 $7C $0E $01 $75 $07
              $C7 $45 $16 $0014W  $EB $25 $83 $7C $0E $FF $75 $07 $C7 $45 $16
              $FFECW  $EB $18 $83 $7C $10 $01 $75 $07 $C7 $45 $18 $0014W  $EB
              $0B $83 $7C $10 $FF $75 $05 $C7 $45 $18 $FFECW  $56 $9A $0D8F0D43RL
                      $83 $C4 $02 $5F $5E $5D $CB




############################################
############BUGBUG REPLACEMENT FOR MAD MUSHROOM
############################################


#put $16540139RL into its collision,  so when keen touches it it fucks up the surrounding tiles (only its look is fucked and returns to normal when you walk away and return)

#Mushroom- behaviour
%patch $30F64 $0FA80BE7RL #Mad Mushroom
%patch $30F82 $09DC16C9RL #Mad Mushroom

#More efficient Mushroom collision
%patch $FF3E  $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $C7 $4C $83 $3C
              $03 $75 $0B $56 $9A $0D8F0D43RL     $83 $C4 $02 $EB $0A $83 $3C
              $02 $75 $05 $9A $0B8013E9RL     $5F $5E $5D $CB

#new collision- bugs up the screen when touched- overtaking 'keen with shifting screen' collision- $0B801632RL    
%patch $CE32  $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $C7 $4C $83 $3C
              $03 $75 $0B $56 $9A $0B801632RL    $83 $C4 $02 $EB $0A $83 $3C
              $02 $75 $05 $9A $16540139RL $5F $5E $5D $CB

#WARNING! It seems to crash the game (to dos) i *think* when it bugs up the screen when you're more on the border of the level. so try to avoid that occurance.

#Mushroom- collision
%patch $30F68 $0B801632RL    #Mad Mushroom
%patch $30F86 $0B801632RL    #Mad Mushroom


#Foreground
%patch $FEE3  $0003W #Mad Mushroom

#Mushrooms- action type
%patch $30F58 $0001W #Mushroom
%patch $30F76 $0003W #Mushroom

#Mushroom- deprotect and stick to ground
%patch $30F60 $0000W $0000W
%patch $30F7E $0000W $0000W

%patch $01F4 $01F4W #Small
%patch $01F4 $01F4W #High
%patch $01F4 $01F4W #Bounce down from ceiling

%patch $30F60 $0064W $01F4W 
%patch $30F7E $01F4W $0064W #-makes enemy erratically bounce and follow keen

#Mushrooms- sprite-tile interaction
#%patch $30F6C $0FA804ECRL    #Bouncing
#%patch $30F8A $0FA80D0BRL    #Bouncing

#Mushrooms
%patch $30F54 $0145W $0147W
%patch $30F5E $0003W        #Animation speed
%patch $30F72 $0146W $0148W
%patch $30F7C $0003W        #Animation speed

#%patch $FF9F $0010W  #Mad Mushroom high bounce sound
%patch $FF9E $EB $0A #Don't play sound

#%patch $FFAD $001CW  #Mad Mushroom low jump sound
%patch $FFAC $EB $0A #Don't play sound









###################################################
#######KREEG REPLACEMENT FOR BERKALOID
###################################################

#caching
%patch $30754 $0205W #Berkeloid cache end

#V distance next to Keen to throw more fireballs:
%patch $10C6D $FF05W #-1 tile
%patch $10C75 $0500W #+1 tile

#Randomly turn to face Keen
%patch $10C1C $80

#Walking frames:
%patch $31968 $01F7W $01FBW $0000W $0000W $0001W $0008W $0060W $0000W
     		  $00000000L $10800530RL $09DC1795RL $2B16W
%patch $31986 $01F8W $01FCW $0000W $0000W $0001W $0008W $0060W $0000W
     		  $00000000L $10800530RL $09DC1795RL $2B34W  
%patch $319A4 $01F9W $01FDW $0000W $0000W $0001W $0008W $0060W $0000W
     		  $00000000L $10800530RL $09DC1795RL $2B52W  
%patch $319C2 $01FAW $01FEW $0000W $0000W $0001W $0008W $0060W $0000W
     		  $1080040BRL $10800530RL $09DC1795RL $2AF8W 

#Creeg firing frames:
%patch $319E0 $01FFW $0201W $0000W $0000W $0001W $0016W $0000W $0000W
     		  $11A20C3BRL $10800530RL $09DC176ERL    $2B8EW
%patch $319FE $0200W $0202W $0000W $0000W $0001W $0008W $0000W $0000W
     		  $11A20C3BRL $10800530RL $09DC176ERL    $2BACW
%patch $31A1C $0200W $0202W $0000W $0000W $0001W $0008W $0000W $0000W
     		  $11A20C3BRL $10800530RL $09DC176ERL    $2BCAW
%patch $31A3A $0200W $0202W $0000W $0000W $0001W $0032W $0000W $0000W
     		  $09DC16C9RL $10800530RL $09DC176ERL    $2AF8W

#in the sprite shooting code- what sprite action comes out when you shoot
%patch $126A6 $3818W

#Seasprite shot- sprite actions
%patch $32688 $0203W $0203W
%patch $32698 $00000000L  	$09DC1752RL	$0FA8097FRL    
%patch $326A6 $0204W $0204W
%patch $326B6 $00000000L  	$09DC1752RL	$0FA8097FRL    
%patch $326C4 $0205W $0205W
%patch $326D4 $00000000L  	$09DC1752RL	$0FA8097FRL    
%patch $326E2 $0204W $0204W
%patch $326F2 $00000000L  	$09DC1752RL $11A20CA1RL        	

#shot clipping
#%patch $1268C $06 $0000W
#shot foreground
%patch $12684 $0003W

#sound- gave creeg shot the dart/lazer sound
%patch $12690 $0029W  

#Sprite shooting height- this changes where the shot comes out from
%patch $1267C $01C2W

#this somehow makes the shot's sound effect more cool
%patch $126B3 $0000W

#sound for when just before Creeg shoots (powers up)- DOESNT WORK RIGHT NOW! SAYS SOUND ISNT CACHED.
#%patch $10C93 $0048W



#######################################
#######PLANT REPLACEMENT FOR SEASPRITE
#######################################

#%patch $3075C $01B5W #Sprite cache end

#Sprite- makes it not float
%patch $125D9 $0000W #Floating u/d speed
%patch $125EF $0000W #Floating u time
%patch $125EF $0000W #Floating d time

#Shooting- makes the sprite instantly shoot
#%patch $32620 $00000000L -initial behaviour- just the bobbing up and down, but turning it off like this makes it not work anymore
%patch $3262E $01B0W $01B2W
%patch $32638 $0001W
%patch $3264C $01B0W $01B2W $0001W
%patch $32656 $0014W        #Pause while making shot
%patch $3266A $01B1W $01B3W $0003W
%patch $32674 $0028W        #Pause before returning to floating

#Sprite clipping
%patch $125A2 $0000W

#Shooting- behaviour- makes it shoot the seed/flame
%patch $3265C $108004A4RL #Sprite shooting
%patch $3267A $00000000L  #Sprite sit after shooting

#Flame origin points- change where the flame/seed emits from
%patch $10CC8 $FD60W #Flame height (8 pixels down)
%patch $10CFA $0120W #Left flame left position (REVERSED, 1 tile left)
%patch $10CE1 $0310W #Right flame right position (2 tiles right)

#new collision for plant- stop bullets but dont kill keen- taking over the mad mushroom collision- $0FA804BERL    
%patch $FF3E $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $C7 $4C $83 
		 $3C $03 $75 $09 $56 $9A $0D8F0D43RL $83 $C4 $02 $5F $5E 
		 $5D $CB 

#plant collision
%patch $32624 $0FA804BERL
%patch $32642 $0FA804BERL
%patch $32660 $0FA804BERL
%patch $3267E $0FA804BERL

#Seed sprites/frames

#Berkeloid tossed flame in air
%patch $31B48 $01B4W $01B4W $0003W 
%patch $31B52 $0016W        #Animation speed
%patch $31B58 $09DC16E5RL #behaviour
%patch $31B60 $1080055ERL    #sprite-tile interaction

%patch $31B66 $01B5W $01B5W $0003W 
%patch $31B70 $0016W        #Animation speed
%patch $31B76 $09DC16E5RL #behaviour
%patch $31B7E $1080055ERL    #sprite-tile interaction
%patch $31B82 $2D14W

%patch $31B84 $01B4W $01B4W $0003W
%patch $31B8E $0016W        #Animation speed
%patch $31B94 $09DC16E5RL #behaviour
%patch $31B9C $1080055ERL    #sprite-tile interaction
%patch $31BA0 $2D32W

%patch $31BA2 $01B5W $01B5W $0003W
%patch $31BAC $0016W        #Animation speed
%patch $31BB2 $09DC16E5RL #behaviour
%patch $31BBA $1080055ERL    #sprite-tile interaction
%patch $31BBE $2CD8W


%patch $31BC0 $01B5W $01B5W $0003W
%patch $31BCA $0016W        #Animation speed
%patch $31BD0 $09DC16E5RL #behaviour
%patch $31BD8 $0FA804ECRL    #sprite-tile interaction
%patch $31BDC $2D6EW

%patch $31BDE $01B4W $01B4W $0003W
%patch $31BE8 $0016W        #Animation speed
%patch $31BEE $09DC16E5RL #behaviour
%patch $31BF6 $0FA804ECRL    #sprite-tile interaction
%patch $31BFA $2D8CW

%patch $31BFC $01B5W $01B5W $0003W
%patch $31C06 $0016W        #Animation speed
%patch $31C0C $09DC16E5RL #behaviour
%patch $31C14 $0FA804ECRL    #sprite-tile interaction
%patch $31C18 $0000W

#in the seed/flame bouncing sprite-tile interaction code- what the seed/flame turns into when it lands
%patch $10D89 $2D50W 

#-so basically the seed animates a few times in the above cycle, the last frame of which makes it disappear.

#$11A20C18RL = $12638

#start of throwing fireball beh. code- $10CA4

#Sound- now emits from when plant fires (put at the end of the 'throwing fireball' behaviour- taking over some of the 'after throwing fireball' behaviour)
%patch $10D19 $B8 $0028W $50 $9A $187409F1RL $83 $C4 $02 $5E $5D $CB

#Berkeloid flame speeds:
%patch $10CDB $0020W #Right
%patch $10CF4 $FFE0W #Left
%patch $10CD0 $FFF0W #Vertical (Up.)
%patch $10D74 $0020W #When hits walls (Fall down, don't bounce off)






##########################################
############SLOP REPLACEMENT FOR BLUE BIRD
###########################################

#caching- make it cache less frames cause i dont need them.
%patch $306F4 $016FW #Blue bird Cache start
%patch $3073E $0176W #Blue bird cache end

#Bird walking- animation
%patch $31044 $0171W $016FW
%patch $3104E $0007W        #Animation speed
%patch $31062 $0172W $0170W
%patch $3106C $0007W        #Animation speed
%patch $3107E $21D4W


#Waiting bird
%patch $31026 $0172W $0170W
%patch $31030 $0001W        #Waiting time
#Bird flying
%patch $310BC $0173W $0173W
%patch $310C6 $0012W        #Animation speed
%patch $310D8 $224CW
#Bird landing
%patch $31134 $0171W $0171W
%patch $3113E $0008W        #Animation speed


%patch $10391 $FFFFW #Speed up when starting left, right or down off ground (turn it off)

%patch $1027D $0000W #Left\right ACCELERATION when flying
%patch $10299 $0000W #Up ACCELERATION when flying
%patch $102AD $0000W #Down ACCELERATION when flying

%patch $1024C $FFFFW #Speed up when launching up off ground
%patch $10391 $FFFFW #Speed up when starting left, right or down off ground

#Flying- behaviour
%patch $310CC $09DC16E5RL #Bird fly
#Landing
%patch $31144 $09DC16C9RL #Berkeloid flame (Bird lands on ground)
#Walking- behaviour
#%patch $31054 $00000000L  #Nothing
%patch $31054 $0FA80779RL #this makes the slop chase keen- but gets a bit weird if it cant get to keen
%patch $31072 $00000000L  #Nothing
#Landing- behaviour

#this stops the slop from trying to 'fly' as it tries to chase keen (which looks weird for my enemy here).
%patch $1022F $21D4W

#BB clipping values- makes the bird 'go down' the sides of walls.
%patch $10247 $0001W #Bird flying (Set when leaving ground)
%patch $102E6 $0001W #Stunned bird (Set when bird stunned)
%patch $10396 $0001W #Bird walking (Set when recovering)
%patch $10496 $0001W #Bird landing 1
%patch $104C3 $0001W #Bird landing 2

#These seem to make the bird land/hit the ground and continue walking properly.
#Seek Keen horizontally while flying
%patch $10273 $0000W
%patch $1027A $FFF0W
#Seek Keen vertically when flying
%patch $1029D $FFF0W
%patch $102B1 $0000W

#Height above ground Bird must be before starting walking (8 pixels)
%patch $10489 $0400W
#%patch $1038B $00

#sprite-tile interaction
#Bird wait
%patch $3103E $0FA80945RL    #Walking Bird
#Bird walk
%patch $3105C $0FA808A1RL #Walking Bird
%patch $3107A $0FA808A1RL #Walking Bird
#Bird fly- these stop the slop from being 'stuck' to the side of walls trying to chase keen
%patch $310D4 $0FA80945RL    #Flying

#Blue bird spawn height
%patch $1006A $FFFFW #15 pixels upwards

#%patch $31162 $09DC16C9RL $00000000L $09DC1913RL  

#slop bits when shot
%patch $31152 $0174W $0174W $0003W $0000W $0000W $0096W $0000W $0000W
              $09DC16C9RL   $00000000L    $0FA8097FRL    $0000W 
%patch $31170 $0175W $0175W $0003W $0000W $0000W $0096W $0000W $0000W
              $09DC16C9RL   $00000000L    $0FA8097FRL    $0000W 
%patch $3118E $0176W $0176W $0003W $0000W $0000W $0096W $0000W $0000W
              $09DC16C9RL   $00000000L    $0FA8097FRL    $0000W 

#foreground for enemy
%patch $10058 $0002W

#Walking- collision
%patch $31058 $2EE7421FRL
%patch $31076 $2EE7421FRL
#Flying
%patch $310D0 $2EE7421FRL

#new collision- explode into bits- using the egg code- overtaking more error messages- $0FA80840RL   
%patch $3308F $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 
	        $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $74 $03 
		  $E9 $008BW  $83 $3D $03 $75 $09 $57 $9A $0D8F0D43RL $83 $C4 $02 
		  $C7 $44 $18 $FFB8W $B8 $22E2W  $50 $56 $9A $09DC120ARL     $83 
		  $C4 $04 $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $8B $44 $0A $89 $47 $0A $8B $44 $0C $89 $47 $0C $C7 $47 $18 
   	        $FFC8W $C7 $47 $16 $001CW $B8 $231EW  $50 $53 $9A $09DC118CRL $83
		  $C4 $04 $B8 $0001W  $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $8B $44 $0A $89 $47 $0A $8B $44 $0C $89 $47 $0C $C7 $47 
		  $16 $0000W  $C7 $47 $18 $FFC8W $C7 $47 $16 $FFE5W $B8 $2300W  $50 
		  $53 $9A $09DC118CRL $83 $C4 $04 $5F $5E $5D $CB

#How far above birds Keen must be before birds fly after him
%patch $10221 $0900W






#########################################
#########SPRINGSHIP REPLACEMENT FOR LICK
###########################################

#NOTE: best to place this enemy in mid-air; placing on the ground makes it appear below the ground and jitter around a bit- the 'position placed in level' code at the end doesnt do a damn thing.

%patch $30702 $01D5W #Lick Cache start
%patch $3074C $01DBW #Lick cache end

#launching off/mid air
%patch $31E36 $01D5W $01D5W $0000W $0000W $0000W $0008W $0000W $0000W
		  $10800B42RL $10800530RL    $0FA804ECRL $2FE4W
%patch $31E54 $01D7W $01D7W $0002W $0000W $0000W $0008W $0000W $0000W
		  $09DC16C9RL $10800530RL    $10800C71RL $0000W
#$3002W
%patch $31E72 $01D8W $01D8W $0000W $0000W $0000W $0008W $0000W $0000W
		  $00000000L $10800530RL    $10800C71RL $3020W

#second launch off
%patch $31E90 $01D5W $01D5W $0000W $0000W $0000W $0008W $0000W $0000W
		  $10800B42RL $10800530RL    $0FA804ECRL $303EW
%patch $31EAE $01D7W $01D7W $0002W $0000W $0000W $0008W $0000W $0000W
		  $09DC16C9RL $10800530RL    $10800B87RL $0000W
#$305CW
%patch $31ECC $01D7W $01D7W $0000W $0000W $0000W $0008W $0000W $0000W
		  $09DC16C9RL $10800530RL    $10800B87RL $307AW

#ship opens up
%patch $31EEA $01D8W $01D8W $0000W $0000W $0000W $0008W $0000W $0000W
		  $00000000L $10800530RL    $09DC176ERL    $3098W
%patch $31F08 $01DAW $01DAW $0003W $0000W $0000W $0024W $0000W $0000W
		  $00000000L $10800BFDRL    $09DC176ERL    $30B6W
%patch $31F26 $01D9W $01D9W $0000W $0000W $0000W $0008W $0000W $0000W
		  $00000000L $10800530RL    $09DC176ERL    $2FC6W

#shot - $30B6W
%patch $31F44 $01DBW $01DBW $0003W $0000W $0000W $0008W $0000W $0000W
		  $09DC16C9RL $00000000L $09DC1913RL    $30D4W

#what enemy becomes when shot
%patch $1140E $30D4W

%patch $1147F $3002W

#second sprite-tile interac - 
%patch $11387 $55 $8B $EC $56 $8B $76 $06 $83 $7C $36 $00 $74 $0D $B8 $305CW 
		  $50 $56 $9A $09DC120ARL $83 $C4 $04 $FF $74 $20 $33 $C0 $50
		  $FF $74 $1E $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A 
		  $16541641RL $83 $C4 $0C $5E $5D $CB

#Lick movement code less flame checks
%patch $11342 $55 $8B $EC $83 $EC $02 $56 $57 $8B $76 $06 $8B $44 $0A $8B $1E #Check Keen's location
              $D6 $A7 $3B $47 $0A $76 $07 $C7 $44 $0E $FFFFW  $EB $05 $C7 $44 #Change H direction to follow him
              $0E $0001W  $8B $44 $0E $B1 $05 $D3 $E0 $89 $44 $16 $C7 $44 $18
              $FFC0W $B8 $002EW $50 $9A $187409F1RL $83 $C4 $02 $5F $5E $8B $E5 $5D $CB  




################################################
####SUPERDUPER REPLACEMENT FOR MIMROCK
##################################################

%patch $306F6 $0184W #Mimrock Cache start
%patch $30740 $018DW #Mimrock cache end

#how far up sprite appears
%patch $11E97 $FF40W

#foreground value
%patch $11E85 $0002W

#standing still-
%patch $322AA $0184W $0184W $0000W $0001W $0001W $0030W $0000W $0000W
		  $00000000L $11A2059FRL    $09DC176ERL $3458W
#walking-    
%patch $322C8 $0188W $0185W $0000W $0001W $0001W $0008W $0040W $0000W
		  $00000000L $11A2059FRL    $09DC1795RL $3476W
%patch $322E6 $0189W $0186W $0000W $0001W $0001W $0008W $0040W $0000W
		  $00000000L $11A2059FRL    $09DC1795RL $3494W
%patch $32304 $018AW $0187W $0000W $0001W $0001W $0008W $0040W $0000W
		  $11A20494RL $11A2059FRL    $09DC1795RL $3458W

#launching off ground- $34B2W
%patch $32322 $018CW $018BW $0003W $0000W $0000W $0016W $0000W $0040W
		  $11A20711RL $09DC1752RL    $11A205C1RL    $34D0W
#flying in the air- $34D0W
%patch $32340 $018CW $018BW $0003W $0000W $0000W $0064W $0000W $0040W
		  $11A20711RL $09DC1752RL       $11A2062ERL    $34EEW
#falling- $34EEW
%patch $3235E $018CW $018BW $0003W $0000W $0000W $0016W $0000W $0000W
		  $09DC16C9RL $09DC1752RL    $11A2062ERL    $34EEW
#hit the ground- $350CW
%patch $3237C $018DW $018DW $0002W $0000W $0000W $0016W $0000W $0000W
		  $09DC16C9RL $00000000L  $09DC1913RL    $350CW

#what superduper turns into when shot (the 'standing still' sprite)
%patch $11FAB $343AW

#what he becomes when he flies
%patch $11F3E $34B2W

#what he becomes when hits the ground
%patch $12000 $350CW
%patch $12068 $350CW

%patch $12014 $00EEW

#new behaviour- mostly the plant's/seasprite's aiming behaviour- taking over the 'look for keen' beh. from original mimrock.- $11A20494RL 
%patch $11EB4 $55 $8B $EC $56 $8B $76 $06 $8B $1E $D6 $A7 $8B $47 $24 $3B 
		  $44 $28 $73 $0D $8B $47 $28 $3B $44 $24 $76 $05 $C7 $44 $1C 
		  $34B2W  $5E $5D $CB

#change sound
%patch $11FEF $0010W  #Mimrock bonk on ground sound- $0010W is pretty good
%patch $1205C $0010W  #Mimrock stop bouncing sound






###############################################
##########SEWAGE SHUTE REPLACEMENT FOR CLOUD 
##############################################

%patch $30708 $01F3W #Cloud Cache start
%patch $30752 $01F6W #Cloud cache end

#Place Cloud in level
%patch $109FE $28DCW #Cloud asleep

%patch $10A36 $0016W #Speed when moving
%patch $10A80 $0016W #After trying to zap Keen

#Moving- collision- makes cloud kill keen
%patch $31760 $09DC1752RL    

#Lightning/sewage
%patch $318B4 $01F5W $01F5W $0003W $0000W $0000W $0000W $0000W $0000W
		  $09DC16E5RL $09DC1752RL $0D8F07EBRL $2A44W
%patch $318D2 $01F6W $01F6W $0003W $0000W $0000W $0030W $0000W $0000W
		  $09DC16E5RL $00000000L $09DC176ERL $0000W 


#new sprite-tile interaction for sewage- taking over some map keen stuff im not using (swimming, foot)- using berkaloid's flame's tile interac. - $0D8F07EBRL
#%patch $E116 
%patch $E0DB $55 $8B $EC $56 $8B $76 $06 $83 $7C $38 $00 $75 $06 $83 $7C 
		 $3C $00 $74 $05 $C7 $44 $16 $0000W $C7 $44 $20 $0003W $83 $7C $36 $00 $74 $19 
		 $B8 $0016W $50 $9A $187409F1RL $83 $C4 $02 $B8 $2A62W
		 $50 $56 $9A $09DC120ARL $83 $C4 $04 $FF $74 $20 $33 $C0 
		 $50 $FF $74 $1E $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 
		 $50 $9A $16541641RL $83 $C4 $0C $5E $5D $CB

#this controls how far below keen is to the cloud/pipe to make it shoot
%patch $10A59 $08

#Clipping
%patch $10B4D $0001W #Cloud Lightening

#Lightning spawn location
%patch $10B5C $0200W #1 tile down
%patch $10B53 $0060W #1 Tile across

#- changed value to 3 to make poison puddle fall, and disappear after a while.
#%patch $30F1C $0003W #Poison slug slime 1
#%patch $30F3A $0003W #Poison slug slime 2

#Cloud zapping actions- makes shot fall early
%patch $317C2 $2A26W #Zap Keen 1

#Zap Keen- behaviours- makes shot fall early
%patch $317B6 $1080032ARL 
%patch $317D4 $00000000L
%patch $317F2 $00000000L
%patch $31810 $00000000L
%patch $3182E $00000000L
%patch $3184C $00000000L
%patch $3186A $00000000L
%patch $31888 $00000000L
%patch $318A6 $00000000L

#Awakening cloud
%patch $3173E $00000000L  #Awake and still (No behavior)
%patch $3177A $10800278RL #Cloud turning
%patch $31798 $1080020CRL #Cloud start moving after zapping- changed to make it be quicker and shoot more

%patch $10A36 $0000W #Speed when moving
#%patch $10A80 $0000W #After trying to zap Keen

#Cloud turning
%patch $3176A $01F3W $01F3W #Turning
%patch $31774 $0000W        #Animation speed
%patch $31788 $01F3W $01F3W #Start moving after zapping Keen
%patch $31792 $0000W        #Animation speed

#Cloud moving
%patch $3174C $01F3W $01F3W
%patch $31756 $0000W        #Animation speed

%patch $317AC $0000W $0002W #Shocking Keen 1
%patch $317CA $0000W $0002W #Shocking Keen 2
%patch $317E8 $0000W $0002W #Shocking Keen 3
%patch $31806 $0000W $0002W #Shocking Keen 4
%patch $31824 $0000W $0002W #Shocking Keen 5
%patch $31842 $0000W $0002W #Shocking Keen 6
%patch $31860 $0000W $0002W #Shocking Keen 7
%patch $3187E $0000W $0002W #Shocking Keen 8
%patch $3189C $0000W $0002W #Shocking Keen 9

%patch $317A4 $0000W #What cloud after zapping does (Return to moving)?

#Moving cloud- this makes the cloud/pipe stay still
%patch $10A73 $2936W #When turning (Cloud stop\start moving)

#clipping- turned it off
%patch $109DA $06 $0000W





########################################
#####MUTATE-O TENTACLE REPLACEMENT FOR WORMOUTH
##########################################

#Cache- using less frames
%patch $30700 $01C9W #Wormouth Cache start
%patch $3074A $01D1W #Wormouth cache end

#Sprite-tile interaction
%patch $31566 $108002E1RL    #Small, moving

#Small Wormouth
%patch $3155A $0010W $0000W #Speed while moving

#Pre-biting- ripple before attack
#$2A80W
%patch $318F0 $01CCW $01CCW $0000W $0000W $0000W $0008W $0000W $0000W 
		  $00000000L $00000000L $09DC176ERL $2A9EW
%patch $3190E $01CDW $01CDW $0000W $0000W $0000W $0008W $0000W $0000W 
		  $00000000L $00000000L $09DC176ERL $2ABCW
%patch $3192C $01CAW $01CAW $0000W $0000W $0000W $0008W $0000W $0000W 
		  $00000000L $00000000L $09DC176ERL $2ADAW
%patch $3194A $01CBW $01CBW $0000W $0000W $0000W $0008W $0000W $0000W 
		  $00000000L $00000000L $09DC176ERL $27ECW


#Biting
%patch $3165C $01CEW $01CEW $0000W $0000W $0000W $0009W $0000W $0000W 
		  $00000000L $00000000L $09DC176ERL 
%patch $3167A $01CFW $01CFW $0000W $0000W $0000W $0009W $0000W $0000W 
		  $00000000L $00000000L $09DC176ERL 
%patch $31698 $01D0W $01D0W $0000W $0000W $0000W $0032W $0000W $0000W 
		  $00000000L $1080017CRL $09DC176ERL 
%patch $316B6 $01CFW $01CFW $0000W $0000W $0000W $0009W $0000W $0000W
		  $00000000L $1080017CRL $09DC176ERL 
%patch $316D4 $01CEW $01CEW $0000W $0000W $0000W $0009W $0000W $0000W
		  $00000000L $00000000L $09DC176ERL 
%patch $316F2 $01D4W $01D4W $0000W $0000W $0000W $0009W $0000W $0000W
		  $00000000L $00000000L $09DC176ERL 

#what enemy turns into when it attacks
%patch $10955 $2A80W

#Looking around
%patch $3156C $01CCW $01CCW
%patch $31576 $0008W        #Animation speed
%patch $3158A $01CDW $01CDW
%patch $31594 $0008W        #Animation speed
%patch $315A8 $01CAW $01CAW
%patch $315B2 $0008W        #Animation speed
%patch $315C6 $01CBW $01CBW
%patch $315D0 $0008W        #Animation speed
%patch $315E4 $01C9W $01C9W 
%patch $315EE $0008W        #Animation speed
%patch $31602 $01C9W $01C9W 
%patch $3160C $0008W        #Animation speed
%patch $31620 $01C9W $01C9W 
%patch $3162A $0008W        #Animation speed
%patch $3163E $01C9W $01C9W
%patch $31648 $0008W        #Animation speed

#Wormouth moving
%patch $3154E $01C9W $01C9W
%patch $31558 $0004W        #Reaction speed

#Wormouth stunned- made the stun sprite 'earlier in the list' than originally, so i can cut out unnecessary frames.
%patch $316F2 $01D1W $01D1W $0003W
%patch $316FC $000AW
%patch $31702 $09DC16C9RL $00000000L  $09DC1913RL $2882W   

#stunned- Deprotect and stick to ground- makes the shot sprite stay still and not drop
%patch $316F8 $0001W $0001W #Stunned


#Look (Related to bite!)- these two parts make wormouth attack where keen is standing (usually attacks a tile or two away)
%patch $108F6 $00 $FF #Look range, tiles, left (-3)
%patch $108FC $00 $00 #Look range, tiles, right (3)
#Bite
%patch $10918 $00 $FC #Bite range, tiles, up (-1)
%patch $1091F $00 $01 #Bite range, tiles, down (+1)
%patch $1092B $80 $FD #Bite right range, tiles, right (+1)
%patch $10931 $80 $FF #Bite right range, tiles, right (+1.5)
%patch $1093D $80     #Bite left range, tiles, right (0.5)
%patch $10942 $00 $FF #Bite left range, tiles, left (-2)

%patch $316F0 $26FCW #Wormouth moving (After biting)

#'new' wormouth biting collision- the original doesnt work for some reason- so just ripped off the blue bird collision code and pasted it over
%patch $1097C $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E 
		  $B8 $2882W $50 $57 $56 $9A $09DC1695RL $83 $C4 $06 $5F $5E $5D $CB


#Look around- behaviours
%patch $3157C $00000000L  #Nothing
%patch $3159A $00000000L  #Nothing
%patch $315B8 $00000000L  #Wormouth look left
%patch $315D6 $00000000L  #Nothing
%patch $315F4 $00000000L  #Nothing
%patch $31612 $00000000L  #Nothing
%patch $31630 $00000000L  #Wormouth look right
%patch $3164E $10800091RL #Head toward Keen

#Wormouth Foreground variable
%patch $10824 $0003W #Wormouth

#Deprotect and stick to ground- not sure if these make any difference
%patch $31572 $0001W $0001W #Looking about 1
%patch $31590 $0001W $0001W #Looking about 2
%patch $315AE $0001W $0001W #Looking about 3
%patch $315CC $0001W $0001W #Looking about 4
%patch $315EA $0001W $0001W #Looking about 5
%patch $31608 $0001W $0001W #Looking about 6
%patch $31626 $0001W $0001W #Looking about 7
%patch $31644 $0001W $0001W #Looking about 8





########################################
######MITE REPLACEMENT FOR SMIRKY
##########################################

#Cache- i made it load less frames to save memory (frames im not using anyway)
%patch $306F0 $0152W #Treasure Eater Cache start
%patch $3073A $0154W #Treasure Eater cache end

#Treasure Eater looks around
%patch $32052 $0152W $0152W
%patch $3205C $0014W        #Animation speed
%patch $32070 $0153W $0153W $0000W $0000W $0000W $0014W $0000W $0000W
              $00000000L  $11A20279RL    $09DC176ERL  $31E2W 

#Treasure eaters kill Keen, shootable (Don't get item sprites)
%patch $11C99 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen, kill
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $32 $C7 $44 $3E $0000W  #Check for Keen's shot (Type 3)
              $C7 $44 $02 $0002W  $C7 $44 $20 $0003W  $8B $04 $89 $44 $44 $C7 #first value = moving when you cant see it; second value = foreground
              $02 $0021W  $57 $9A $0D8F0D43RL    $83 $C4 $02 $B8 $3386W  $50 #Change Treasure Eater type and action
              $56 $9A $09DC120ARL    $83 $C4 $04 $83 $6C $18 $10 $5F $5E $5D
              $CB

#These patches make it so I'm only using the most minimal amount of frames that i need for the caching (to save memory). 

#Stunned Treasure Eater in air
%patch $321F6 $0154W $0154W
%patch $32200 $0000W        #Wait to hit ground
#Stunned Treasure Eater
%patch $32214 $0154W $0154W
%patch $3221E $0000W        #Do nothing

#clipping
%patch $11A46 $06 $0000W

#Shot- sprite-tile interaction
%patch $3220E $09DC176ERL    #Shot sprite
%patch $3222C $09DC176ERL    #Shot sprite

#spawning position
%patch $11A5E $FF16W

#foreground value
%patch $11A4C $0002W








#########################################
##########BOSS, 'MEGABOSS 5000' REPLACEMENT FOR DOPEFISH
##########################################

%patch $EEA1 $0255W #Dopefish tile (At $EB45)

#Dopefish Initiation code- took out the difficulty check
%patch $EB45 $FF $76 $FC $57 $9A $11A20690RL $83 $C4 $04 $C7 $06 $63 $CB
             $0001W  $E9 $02A2W

#eats keen.
%patch $12411 $90 $36 #Kill Keen if eaten

#Keen eaten by Dopefish
%patch $32520 $0139W $0139W
%patch $3252A $0000W        #Wait for Dopefish
%patch $3253E $FFFFW $FFFFW #Erase sprite
%patch $32548 $00B4W        #Pause before level exit box

#Swimming- behaviours
%patch $32440 $11A20974RL 

#Swimming- collisions
%patch $32444 $11A209B0RL    

#Slime- behaviours- this makes the puddles fall
%patch $30F28 $11A20E01RL #Nothing
%patch $30F46 $11A20E01RL #Nothing

#Slime- collision
%patch $30F2C $00000000L  	#Kill Keen
%patch $30F4A $00000000L  	#No collision

#Poison slug slime- makes slime 'dry' quicker (to get it out of there to free up memory)
%patch $30F18 $0143W $0143W
%patch $30F22 $0078W        #Time before half-dry
%patch $30F36 $0144W $0144W
%patch $30F40 $003CW        #Time before vanishing

#Action Type- value of hex is -12 from behaviour
#Swimming
%patch $32434 $0000W 
#%patch $32452 $0000W 

#Slime- action type
%patch $30F1C $0004W #Poison slug slime 1
%patch $30F3A $0004W #Poison slug slime 2

#Dopefish swimming speeds
%patch $12157 $0032W #Sideways
%patch $12173 $0032W #Down
%patch $12187 $0032W #Up

#Swimming
%patch $3243C $0000W $0032W #Speed 1
%patch $3245A $0000W $0032W #Speed 2

#Dopefish never eats Keen, even without god mode
%patch $123F9 $EB


#movement frames
%patch $32430 $0194W $0194W $0000W $0000W $0000W $0009W $0090W $0000W
		  $11A20912RL $09DC1752RL    $09DC176ERL    $35DEW
%patch $3244E $0196W $0196W $0003W $0000W $0000W $0009W $0090W $0000W
		  $11A20AF6RL $09DC1752RL    $09DC176ERL    $35FCW
%patch $3246C $0195W $0195W $0003W $0000W $0000W $0009W $0090W $0000W
		  $11A20AF6RL $11A209B0RL    $09DC176ERL    $35C0W

#movement frames- for easy mode boss- $2DC8W
%patch $31C38 $0194W $0194W $0000W $0000W $0000W $0009W $0070W $0000W
		  $11A20912RL $09DC1752RL    $09DC176ERL    $2DE6W
%patch $31C56 $0196W $0196W $0003W $0000W $0000W $0009W $0070W $0000W
		  $11A20AF6RL $09DC1752RL    $09DC176ERL    $2E04W
%patch $31C74 $0195W $0195W $0003W $0000W $0000W $0009W $0070W $0000W
		  $11A20AF6RL $11A209B0RL    $09DC176ERL    $2DC8W



#After dopefish bites
%patch $3248A $0197W $0197W $0003W $0000W $0000W $0022W $0000W $0000W
		  $11A2086ERL $00000000L $11A20A3CRL $3638W
%patch $324A8 $0198W $0198W $0003W $0000W $0000W $0022W $0000W $0000W
		  $09DC16C9RL $00000000L $0FA8097FRL    $3656W
%patch $324C6 $01A2W $01A2W $0003W $0000W $0000W $0022W $0000W $0000W
		  $00000000L  $00000000L $09DC176ERL    $3674W   
%patch $324E4 $01A3W $01A3W $0003W $0000W $0000W $0022W $0000W $0000W
		  $00000000L  $00000000L $09DC176ERL    $3656W

#makes a sound when boss dies- overtaking 'dopefish snaking on sprite' beh. - $11A2086ERL 
%patch $1228E $55 $8B $EC $56 $8B $76 $06 $B8 $01 $00 $50 $9A $06BD1E11RL 
		  $83 $C4 $02 $8B $44 $0A $05 $80 $03 $8B $1E $D8 $A7 $89 
		  $47 $0A $8B $44 $0C $05 $00 $02 $89 $47 $0C $C7 $07 $01 $00 
		  $C7 $47 $20 $03 $00 $B8 $0006W $50 $9A $187409F1RL 
		  $83 $C4 $02 $5E $5D $CB

#seems to be code for the dopefish eating
%patch $12423 $8B $44 $0A $89 $44 $40 $8B $44 $0C $89 $44 $42 $89 $7C $44 
		  $8B $45 $2A $3B $44 $2A $73 $07 $C7 $44 $0E $FFFFW  $EB $05 
		  $C7 $44 $0E $0001W  $B8 $361AW  $50 $56 $9A $09DC120ARL     
		  $83 $C4 $04 $C7 $44 $06 $0002W  $5F $5E $5D $CB

#sprite actions for the bubbles (makes them animate)
%patch $32560 $0003W
%patch $3257E $0003W
%patch $3259C $0003W
%patch $325BA $0003W

#bubble anim speed
%patch $32566 $0032W
%patch $32584 $0032W
%patch $325A2 $0032W
%patch $325C0 $0032W

#sprite action- makes the smoke/bubbles anim not loop
%patch $325B4 $0000W

#around where the bubble spawning code seems to be (this points to the bubble sprite action)
#%patch $12379

#for bubbles- makes them break up more the higher the value
#%patch $12376 $0004W

#bubble clipping
%patch $12367 $0000W

#%patch $1236C $FFFEW

#affects how upward the bubbles travel
%patch $12371 $FFFFW

#for how much the bubble's wobble left and right
#%patch $12376 $0032W

#Dopefish collision - this has no effect on keen anymore- 2 of the 3 movement frames have the standard 'kill keen' code, only 1 of the frames has this one, for 'eating' the 'schoolfish'.
%patch $123D0 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $16 $75 
		  $0F $B8 $3692W  $50 $57 $9A $09DC120ARL     $83 $C4 $04 $EB 
		  $34 $83 $3D $16 $75 $64 $83 $3E $29 $C6 $00 $75 $5D $C7 $05 
		  $0001W  $C7 $45 $06 $0000W  $B8 $17 $00 $50 $9A $F1 $09 $3C 
	 	  $1F $83 $C4 $02 $B8 $B0 $36 $50 $57 $9A $0B8013E9RL     $83 #that XXXXXXXXRL pointer goes now to the kill keen code
		  $C4 $04 $EB $04 $5F $5E $5D $CB

#Dopefish spawn code- i put a jump condition near the end that makes the dopefish go to a similar (yet slower) group of sprite actions for easy mode.
%patch $120B0 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0015W  $C7 $47 $02 $0001W  $C7 $47 $20 $0003W #Sprite type = 15, ??? = 1, fore = 2
              $C7 $47 $06 $0000W $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B 				
              $46 $08 $D3 $E0 $05 $FD00W  $89 $47 $0C $9A $1D02002ARL     $3D
              $0080W   $8B $1E $D8 $A7 $C7 $47 $10 $0001W $83 $3E $7A6CW $01 $75 $03 $E9 $0006W
                  $B8 $35C0W $E9 $0003W $B8 $2DC8W $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5D $CB









################################################
######### 'KILL BOSS' DUMMY SPRITE THAT KILLS THE BOSS, REPLACEMENT FOR SCHOOLFISH
##############################################

#this turns off schoolfish's caching (since its invisible now)
%patch $EB7E $0000W

#collision
%patch $325E8 $09DC1752RL
%patch $32606 $09DC1752RL

#sprite-tile interaction- turned it off so you cant see it
%patch $325EC $00000000L
%patch $3260A $00000000L
%patch $3251A $00000000L

#Schoolfish swim
%patch $325D4 $01A5W $01A5W
%patch $325DE $0000W        #Animation speed
%patch $325F2 $01A5W $01A5W
%patch $325FC $0000W        #Animation speed

#Swimming fish
%patch $325F0 $3782W #Schoolfish 1
%patch $3260E $3782W #Schoolfish 2 [Go to 1

#Dead Schoolfish
%patch $32502 $01A5W $01A5W
%patch $3250C $0000W

#Swimming- behaviour- makes him still
%patch $325E4 $00000000L  #Seek Keen
%patch $32602 $00000000L  #Seek Keen




###############################################
########BOBBLE PLANT REPLACEMENT FOR EGG
###############################################

#egg/plant produces extra piece of shell/leaf when shot
%patch $10135 $215CW

#the big chunk of egg thats left over when shot has the wetsuit collision (is the 'uncovered' plant)
%patch $30FC2 $11A21010RL

#Wetsuit sprite collision- the $7A3CW is the check for marking level 15 be completed- to 'extend the bridges'
%patch $12A30 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $3C $02 $75 $2B
              $C7 $06 $7A3CW  $0001W  $B8 $002DW  $50
              $9A $187409F1RL     $83 $C4 $02 $9A $0E8F0AE2RL     $9A $16540D59RL
                      $C7 $06 $7A70W  $0002W  $83 $C7 $4C $5F $5E $5D $CB

#NOTE: So, the highest level i can get to take off tiles in the map (to 'extend the bridges') apparently is level 15- so i made this set the level 15 game stat as complete. 
#and it makes no difference to the rest of the game cause at the end of level 15 the game ends anyways.


#makes only shooting it burst the plant- touching it does nothing now
%patch $100B9 $03

#Foreground
%patch $FFFB  $0000W #Egg

#what keen says when you get the wetsuit/button
%patch $30A25 "Huh, so its a button." $0A 
		  "This one probably" $0A 
		  "extends the bridges." $00

%patch $F435 $1BB5W #Text read from

#speeds of falling petals
%patch $10169 $FF64W #Left speed (Left shell)
%patch $1016E $FFFFW #Up speed (Left shell)
%patch $101A5 $000CW #Right speed (Right shell)
%patch $101AA $FFFFW #Up speed (Right shell)
%patch $101E1 $0006W #Horizontal speed (Up shell)
%patch $101E6 $FFFFW #Up speed (Up shell)

#foreground value for the petals
%patch $100F9 $20 $0003W
%patch $10157 $20 $0003W
%patch $10193 $20 $0003W
%patch $101CF $20 $0003W




################################################
############BWB MEGAROCKET SPRITE REPLACEMENT FOR WETSUIT SPRITE
################################################

#collision
%patch $328B8 $00000000L #Wetsuit

#foreground
%patch $12A09 $20 $0000W




###############################################

#These are for the 'stars' that appear when enemies get stunned.
#'The Slug for example has a value of 0 for this variable, assigning it to type 8 in the list.)
#Each type can change the horizontal and\or vertical position of the stars relative to the sprite. 
#$Bf $xxxxW is the vertical position and $C7... the horizontal. It takes trial and error to adjust 
#these stars correctly.'

#NOTE: its the enemy's sprite type which causes them to have their particular stun sprite value.

#List
%patch $B7E2 $19CBW #B78B: 8
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $1997W #B757: 2
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19B2W #B772: 5
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19A8W #B768: 4
             $19C1W #B781: 7
             $19CEW #B78E: 9
             $19BCW #B77C: 6
             $1992W #B752: 1
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19CEW #B78E: 9
             $19A1W #B761: 3

#Type 1
%patch $B752 $BF $FFC0W  $EB $37

#Type 2
%patch $B757 $C7 $46 $FE $0080W  $BF $FF80W  $EB $2D

#Type 3
%patch $B761 $C7 $46 $FE $0080W $EB $26

#Type 4
%patch $B768 $C7 $46 $FE $0040W  $BF $FF80W $EB $1C

#Type 5
%patch $B772 $C7 $46 $FE $0040W  $BF $FEA2W  $EB $12

#Type 6
%patch $B77C $BF $FF80W  $EB $0D

#Type 7
%patch $B781 $C7 $46 $FE $FFC0W  $BF $FF80W  $EB $03

#Type 8 (Same as type 6) (for slug/beserky)
%patch $B78B $BF $FF00W #highest i can get it 

#Type 9 (No changes made)




##########################################
############PALETTE
##########################################

#Terminator text palette: blue style
#%patch $2F078 $00 $01 $01 $03 $01 $01 $01 $07 #Dark colors
#              $11 $11 $11 $1B $13 $13 $13 $13 #Light colors

#Terminator text palette: green style
#%patch $2F078 $00 $02 $02 $02 $02 $02 $02 $02 #Dark colors
#              $02 $02 $02 $02 $1A $1A $1A $1A #Light colors

#Terminator text palette: red style
%patch $2F078 $00 $04 $04 $04 $04 $04 $04 $04 #Dark colors
              $04 $04 $04 $04 $1C $1C $1C $1C #Light colors







###########################################

#NOTES#

#for figuring out XXXXXXXXRL code in that Xy program- the last call/offset is correct, but take 6C8 off the segment code and you got the actual segment

#this creates a box for text- 9A $19311070RL -  and the next far call in the code is for the text in the box

#sometimes the level loading anim (anim of keen smoking) doesn't come up. It may have to do with the flag level marker behaviour which i edited.

#the mimrock now has a bunch of free sprite spots (atleast the last few)

#The Blue Bird now has some unused sprite spots

#part of inchworm collision location used 

#not using the usual blue bird collision code, starting at $102C0W - free to use up space 

#all that DOS initilialisng screen space is now up for grabs- but i think code used over it makes it not work right (tried it, didnt work- put the code somewhere else, it worked)

%end